/* A Bison parser, made by GNU Bison 3.0.5.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         rpslparse
#define yylex           rpsllex
#define yyerror         rpslerror
#define yydebug         rpsldebug
#define yynerrs         rpslnerrs

#define yylval          rpsllval
#define yychar          rpslchar

/* Copy the first part of user declarations.  */
#line 1 "rpsl.y" /* yacc.c:339  */

// Copyright (c) 2001,2002                        RIPE NCC
//
// All Rights Reserved
//
// Permission to use, copy, modify, and distribute this software and its
// documentation for any purpose and without fee is hereby granted,
// provided that the above copyright notice appear in all copies and that
// both that copyright notice and this permission notice appear in
// supporting documentation, and that the name of the author not be
// used in advertising or publicity pertaining to distribution of the
// software without specific, written prior permission.
//
// THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
// ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS; IN NO EVENT SHALL
// AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY
// DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
// AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
// OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
//
//  $Id$
//
//  Copyright (c) 1994 by the University of Southern California
//  All rights reserved.
//
//    Permission is hereby granted, free of charge, to any person obtaining a copy
//    of this software and associated documentation files (the "Software"), to deal
//    in the Software without restriction, including without limitation the rights
//    to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//    copies of the Software, and to permit persons to whom the Software is
//    furnished to do so, subject to the following conditions:
//
//    The above copyright notice and this permission notice shall be included in
//    all copies or substantial portions of the Software.
//
//    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//    THE SOFTWARE.
//
//  Questions concerning this software should be directed to
//  irrtoolset@cs.usc.edu.
//
//  Author(s): Cengiz Alaettinoglu <cengiz@ISI.EDU>
//             Katie Petrusha <katie@ripe.net>

#include "config.h"
#include "time.h"
#include "schema.hh"
#include "object.hh"
#include "regexp.hh"
#include "rptype.hh"

#ifdef ENABLE_DEBUG
#define YYDEBUG 1
#endif // ENABLE_DEBUG
#if YYDEBUG != 0
// stdio is needed for yydebug
#include <cstdio>
#endif

extern "C" {
#ifdef HAVE_REGEX_H
#include <regex.h>
#else
#include <gnu/regex.h>
#endif
}

extern void handle_error(const char *, ...);
extern void handle_object_error(const char *, ...);
extern void handle_warning(const char *, ...);
extern int yylex();
char *token_name(int token_id);
void rpslerror(const char *s, ...);
Attr *changeCurrentAttr(Attr *b);
void handleArgumentTypeError(char *attr, const char *method, int position,
			     const RPType *correctType, 
			     bool isOperator = false);
const AttrMethod *searchMethod(const AttrRPAttr *rp_attr, const char *method, ItemList *args);

/* argument to yyparse result of parsing should be stored here */
#define yyschema schema
#define enable_yy_parser_debugging enable_rpsl_parser_debugging

extern Object *current_object;


#line 166 "rpsl.y.cc" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "rpsl.y.hh".  */
#ifndef YY_RPSL_RPSL_Y_HH_INCLUDED
# define YY_RPSL_RPSL_Y_HH_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int rpsldebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    KEYW_TRUE = 258,
    KEYW_FALSE = 259,
    KEYW_ACTION = 260,
    KEYW_ACCEPT = 261,
    KEYW_ANNOUNCE = 262,
    KEYW_FROM = 263,
    KEYW_TO = 264,
    KEYW_AT = 265,
    KEYW_ANY = 266,
    KEYW_REFINE = 267,
    KEYW_EXCEPT = 268,
    KEYW_STATIC = 269,
    KEYW_NETWORKS = 270,
    KEYW_MASKLEN = 271,
    KEYW_UNION = 272,
    KEYW_RANGE = 273,
    KEYW_LIST = 274,
    KEYW_OF = 275,
    KEYW_OPERATOR = 276,
    KEYW_SYNTAX = 277,
    KEYW_SPECIAL = 278,
    KEYW_REGEXP = 279,
    KEYW_OPTIONAL = 280,
    KEYW_MANDATORY = 281,
    KEYW_INTERNAL = 282,
    KEYW_SINGLEVALUED = 283,
    KEYW_MULTIVALUED = 284,
    KEYW_LOOKUP = 285,
    KEYW_KEY = 286,
    KEYW_DELETED = 287,
    KEYW_OBSOLETE = 288,
    KEYW_PEERAS = 289,
    KEYW_PROTOCOL = 290,
    KEYW_INTO = 291,
    KEYW_ATOMIC = 292,
    KEYW_INBOUND = 293,
    KEYW_OUTBOUND = 294,
    KEYW_UPON = 295,
    KEYW_HAVE_COMPONENTS = 296,
    KEYW_EXCLUDE = 297,
    KEYW_AFI = 298,
    KEYW_TUNNEL = 299,
    TKN_ERROR = 300,
    TKN_UNKNOWN_CLASS = 301,
    TKN_EOA = 302,
    TKN_EOO = 303,
    TKN_FREETEXT = 304,
    TKN_INT = 305,
    TKN_REAL = 306,
    TKN_STRING = 307,
    TKN_TIMESTAMP = 308,
    TKN_BLOB = 309,
    TKN_IPV4 = 310,
    TKN_PRFXV4 = 311,
    TKN_PRFXV4RNG = 312,
    TKN_IPV6 = 313,
    TKN_PRFXV6 = 314,
    TKN_PRFXV6RNG = 315,
    TKN_ASNO = 316,
    TKN_ASNAME = 317,
    TKN_RSNAME = 318,
    TKN_RTRSNAME = 319,
    TKN_PRNGNAME = 320,
    TKN_FLTRNAME = 321,
    TKN_BOOLEAN = 322,
    TKN_WORD = 323,
    TKN_RP_ATTR = 324,
    TKN_DNS = 325,
    TKN_EMAIL = 326,
    TKN_3DOTS = 327,
    TKN_AFI = 328,
    ATTR_GENERIC = 329,
    ATTR_BLOBS = 330,
    ATTR_REGEXP = 331,
    ATTR_IMPORT = 332,
    ATTR_MP_IMPORT = 333,
    ATTR_EXPORT = 334,
    ATTR_MP_EXPORT = 335,
    ATTR_DEFAULT = 336,
    ATTR_MP_DEFAULT = 337,
    ATTR_FREETEXT = 338,
    ATTR_CHANGED = 339,
    ATTR_IFADDR = 340,
    ATTR_INTERFACE = 341,
    ATTR_PEER = 342,
    ATTR_MP_PEER = 343,
    ATTR_INJECT = 344,
    ATTR_V6_INJECT = 345,
    ATTR_COMPONENTS = 346,
    ATTR_V6_COMPONENTS = 347,
    ATTR_AGGR_MTD = 348,
    ATTR_AGGR_BNDRY = 349,
    ATTR_RS_MEMBERS = 350,
    ATTR_RS_MP_MEMBERS = 351,
    ATTR_RTR_MP_MEMBERS = 352,
    ATTR_RP_ATTR = 353,
    ATTR_TYPEDEF = 354,
    ATTR_PROTOCOL = 355,
    ATTR_FILTER = 356,
    ATTR_V6_FILTER = 357,
    ATTR_MP_FILTER = 358,
    ATTR_MP_PEVAL = 359,
    ATTR_PEERING = 360,
    ATTR_MP_PEERING = 361,
    ATTR_ATTR = 362,
    ATTR_MNT_ROUTES = 363,
    ATTR_MNT_ROUTES6 = 364,
    ATTR_MNT_ROUTES_MP = 365,
    OP_OR = 366,
    OP_AND = 367,
    OP_NOT = 368,
    OP_MS = 369,
    TKN_OPERATOR = 370
  };
#endif
/* Tokens.  */
#define KEYW_TRUE 258
#define KEYW_FALSE 259
#define KEYW_ACTION 260
#define KEYW_ACCEPT 261
#define KEYW_ANNOUNCE 262
#define KEYW_FROM 263
#define KEYW_TO 264
#define KEYW_AT 265
#define KEYW_ANY 266
#define KEYW_REFINE 267
#define KEYW_EXCEPT 268
#define KEYW_STATIC 269
#define KEYW_NETWORKS 270
#define KEYW_MASKLEN 271
#define KEYW_UNION 272
#define KEYW_RANGE 273
#define KEYW_LIST 274
#define KEYW_OF 275
#define KEYW_OPERATOR 276
#define KEYW_SYNTAX 277
#define KEYW_SPECIAL 278
#define KEYW_REGEXP 279
#define KEYW_OPTIONAL 280
#define KEYW_MANDATORY 281
#define KEYW_INTERNAL 282
#define KEYW_SINGLEVALUED 283
#define KEYW_MULTIVALUED 284
#define KEYW_LOOKUP 285
#define KEYW_KEY 286
#define KEYW_DELETED 287
#define KEYW_OBSOLETE 288
#define KEYW_PEERAS 289
#define KEYW_PROTOCOL 290
#define KEYW_INTO 291
#define KEYW_ATOMIC 292
#define KEYW_INBOUND 293
#define KEYW_OUTBOUND 294
#define KEYW_UPON 295
#define KEYW_HAVE_COMPONENTS 296
#define KEYW_EXCLUDE 297
#define KEYW_AFI 298
#define KEYW_TUNNEL 299
#define TKN_ERROR 300
#define TKN_UNKNOWN_CLASS 301
#define TKN_EOA 302
#define TKN_EOO 303
#define TKN_FREETEXT 304
#define TKN_INT 305
#define TKN_REAL 306
#define TKN_STRING 307
#define TKN_TIMESTAMP 308
#define TKN_BLOB 309
#define TKN_IPV4 310
#define TKN_PRFXV4 311
#define TKN_PRFXV4RNG 312
#define TKN_IPV6 313
#define TKN_PRFXV6 314
#define TKN_PRFXV6RNG 315
#define TKN_ASNO 316
#define TKN_ASNAME 317
#define TKN_RSNAME 318
#define TKN_RTRSNAME 319
#define TKN_PRNGNAME 320
#define TKN_FLTRNAME 321
#define TKN_BOOLEAN 322
#define TKN_WORD 323
#define TKN_RP_ATTR 324
#define TKN_DNS 325
#define TKN_EMAIL 326
#define TKN_3DOTS 327
#define TKN_AFI 328
#define ATTR_GENERIC 329
#define ATTR_BLOBS 330
#define ATTR_REGEXP 331
#define ATTR_IMPORT 332
#define ATTR_MP_IMPORT 333
#define ATTR_EXPORT 334
#define ATTR_MP_EXPORT 335
#define ATTR_DEFAULT 336
#define ATTR_MP_DEFAULT 337
#define ATTR_FREETEXT 338
#define ATTR_CHANGED 339
#define ATTR_IFADDR 340
#define ATTR_INTERFACE 341
#define ATTR_PEER 342
#define ATTR_MP_PEER 343
#define ATTR_INJECT 344
#define ATTR_V6_INJECT 345
#define ATTR_COMPONENTS 346
#define ATTR_V6_COMPONENTS 347
#define ATTR_AGGR_MTD 348
#define ATTR_AGGR_BNDRY 349
#define ATTR_RS_MEMBERS 350
#define ATTR_RS_MP_MEMBERS 351
#define ATTR_RTR_MP_MEMBERS 352
#define ATTR_RP_ATTR 353
#define ATTR_TYPEDEF 354
#define ATTR_PROTOCOL 355
#define ATTR_FILTER 356
#define ATTR_V6_FILTER 357
#define ATTR_MP_FILTER 358
#define ATTR_MP_PEVAL 359
#define ATTR_PEERING 360
#define ATTR_MP_PEERING 361
#define ATTR_ATTR 362
#define ATTR_MNT_ROUTES 363
#define ATTR_MNT_ROUTES6 364
#define ATTR_MNT_ROUTES_MP 365
#define OP_OR 366
#define OP_AND 367
#define OP_NOT 368
#define OP_MS 369
#define TKN_OPERATOR 370

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 98 "rpsl.y" /* yacc.c:355  */

   long long int      i;
   double             real;
   char              *string;
   void              *ptr;
   time_t             time;
   Item              *item;
   ItemList          *list;
   regexp            *re;
   SymID              sid;
   IPAddr            *ip;
   Prefix            *prfx;
   PrefixRange       *prfxrng;
   IPv6Addr          *ipv6;
   IPv6Prefix        *prfxv6;
   IPv6PrefixRange   *prfxv6rng;
   AddressFamily     *afi;
   RPType            *typenode;
   MPPrefix          *mpprefix;
   Tunnel            *tunnel;

   Filter                    *filter;
   FilterMS                  *moreSpecOp;
   PolicyPeering             *peering;
   PolicyPeering             *mp_peering;
   PolicyActionList          *actionList;
   PolicyAction              *actionNode;
   PolicyFactor              *policyFactor;
   PolicyTerm                *policyTerm;
   PolicyExpr                *policyExpr;
   List<PolicyPeeringAction> *peeringActionList;

   Attr               *attr;
   AttrAttr           *rpslattr;
   AttrMethod         *method;
   const AttrRPAttr   *rp_attr;
   const AttrProtocol *protocol;
   AttrProtocolOption *protocol_option;
   List<AttrProtocolOption> *protocol_option_list;

   AttrPeerOption       *peer_option;
   List<AttrPeerOption> *peer_option_list;

   List<RPTypeNode> *typelist;
   List<AttrMethod> *methodlist;
   List<WordNode>   *wordlist;

   List<AttrMntRoutes::MntPrfxPair> *listMntPrfxPair;
   AttrMntRoutes::MntPrfxPair       *mntPrfxPair;

#line 487 "rpsl.y.cc" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE rpsllval;

int rpslparse (void);

#endif /* !YY_RPSL_RPSL_Y_HH_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 504 "rpsl.y.cc" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  315
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1911

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  136
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  173
/* YYNRULES -- Number of rules.  */
#define YYNRULES  575
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  976

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   370

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,   135,     2,     2,     2,
     121,   122,   130,   132,   116,   117,   123,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   118,   124,
     127,     2,   128,   131,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   125,     2,   126,   134,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   119,   129,   120,   133,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   461,   461,   464,   467,   471,   474,   477,   481,   486,
     489,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   534,   543,
     547,   553,   564,   607,   616,   624,   627,   630,   634,   640,
     643,   651,   655,   661,   664,   669,   672,   675,   678,   681,
     684,   687,   690,   693,   696,   699,   702,   705,   708,   711,
     714,   717,   720,   723,   726,   729,   732,   735,   738,   741,
     744,   749,   752,   757,   760,   763,   766,   769,   772,   778,
     781,   784,   787,   790,   793,   796,   799,   802,   805,   808,
     811,   814,   817,   820,   823,   826,   829,   832,   835,   838,
     841,   844,   847,   850,   853,   856,   859,   862,   865,   868,
     871,   874,   877,   880,   883,   886,   889,   898,   901,   904,
     907,   910,   913,   916,   919,   922,   925,   928,   931,   938,
     941,   946,   949,   954,   957,   960,   963,   966,   970,   973,
     976,   979,   982,   985,   992,   995,  1002,  1005,  1010,  1015,
    1022,  1032,  1045,  1054,  1063,  1071,  1074,  1077,  1080,  1083,
    1086,  1089,  1092,  1095,  1098,  1101,  1107,  1110,  1113,  1117,
    1120,  1123,  1126,  1129,  1132,  1137,  1140,  1145,  1149,  1156,
    1159,  1164,  1167,  1170,  1173,  1176,  1179,  1182,  1185,  1188,
    1191,  1194,  1197,  1200,  1203,  1206,  1209,  1212,  1215,  1218,
    1221,  1227,  1230,  1233,  1236,  1239,  1242,  1247,  1257,  1270,
    1279,  1292,  1296,  1302,  1306,  1314,  1321,  1325,  1331,  1338,
    1342,  1350,  1355,  1360,  1365,  1372,  1375,  1378,  1383,  1386,
    1389,  1396,  1399,  1409,  1412,  1423,  1428,  1434,  1439,  1446,
    1451,  1457,  1462,  1470,  1473,  1476,  1481,  1484,  1487,  1494,
    1500,  1508,  1514,  1524,  1529,  1533,  1539,  1544,  1548,  1556,
    1560,  1566,  1570,  1578,  1581,  1584,  1587,  1590,  1593,  1596,
    1599,  1602,  1605,  1608,  1614,  1617,  1620,  1624,  1627,  1630,
    1633,  1636,  1639,  1644,  1647,  1650,  1654,  1660,  1663,  1666,
    1669,  1676,  1681,  1688,  1691,  1696,  1699,  1704,  1707,  1710,
    1713,  1716,  1719,  1722,  1725,  1728,  1731,  1734,  1737,  1744,
    1749,  1755,  1762,  1767,  1773,  1780,  1783,  1790,  1795,  1801,
    1809,  1815,  1821,  1827,  1830,  1837,  1847,  1856,  1859,  1866,
    1873,  1882,  1891,  1894,  1903,  1906,  1917,  1920,  1926,  1932,
    1938,  1947,  1950,  1955,  1958,  1968,  1979,  1984,  1989,  1994,
    2003,  2006,  2011,  2015,  2021,  2026,  2027,  2030,  2033,  2038,
    2094,  2101,  2107,  2116,  2173,  2180,  2186,  2193,  2196,  2199,
    2202,  2206,  2218,  2221,  2228,  2231,  2234,  2237,  2240,  2243,
    2246,  2249,  2252,  2255,  2258,  2264,  2267,  2270,  2274,  2277,
    2280,  2283,  2286,  2289,  2294,  2297,  2300,  2304,  2311,  2314,
    2321,  2324,  2331,  2333,  2336,  2347,  2354,  2361,  2364,  2369,
    2372,  2376,  2379,  2382,  2385,  2388,  2391,  2394,  2401,  2405,
    2412,  2415,  2418,  2423,  2428,  2437,  2440,  2445,  2448,  2451,
    2454,  2457,  2460,  2463,  2466,  2469,  2474,  2480,  2489,  2490,
    2493,  2495,  2498,  2504,  2507,  2516,  2519,  2524,  2528,  2534,
    2537,  2541,  2544,  2548,  2551,  2555,  2558,  2563,  2566,  2575,
    2578,  2583,  2587,  2593,  2596,  2600,  2603,  2607,  2610,  2614,
    2617,  2620,  2623,  2628,  2631,  2640,  2643,  2646,  2653,  2658,
    2665,  2668,  2671,  2674,  2681,  2688,  2693,  2698,  2702,  2710,
    2713,  2720,  2725,  2732,  2739,  2746,  2753,  2760,  2767,  2775,
    2786,  2793,  2800,  2804,  2812,  2815,  2820,  2827,  2830,  2836,
    2839,  2846,  2849,  2856,  2859,  2864,  2870,  2873,  2882,  2894,
    2906,  2909,  2912,  2915,  2918,  2921,  2924,  2927,  2930,  2935,
    2939,  2945,  2955,  2960,  2964,  2970,  2973,  2976,  2983,  2987,
    2991,  2997,  3000,  3003,  3010,  3014,  3018,  3024,  3027,  3030,
    3043,  3046,  3053,  3058,  3065,  3068
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "KEYW_TRUE", "KEYW_FALSE", "KEYW_ACTION",
  "KEYW_ACCEPT", "KEYW_ANNOUNCE", "KEYW_FROM", "KEYW_TO", "KEYW_AT",
  "KEYW_ANY", "KEYW_REFINE", "KEYW_EXCEPT", "KEYW_STATIC", "KEYW_NETWORKS",
  "KEYW_MASKLEN", "KEYW_UNION", "KEYW_RANGE", "KEYW_LIST", "KEYW_OF",
  "KEYW_OPERATOR", "KEYW_SYNTAX", "KEYW_SPECIAL", "KEYW_REGEXP",
  "KEYW_OPTIONAL", "KEYW_MANDATORY", "KEYW_INTERNAL", "KEYW_SINGLEVALUED",
  "KEYW_MULTIVALUED", "KEYW_LOOKUP", "KEYW_KEY", "KEYW_DELETED",
  "KEYW_OBSOLETE", "KEYW_PEERAS", "KEYW_PROTOCOL", "KEYW_INTO",
  "KEYW_ATOMIC", "KEYW_INBOUND", "KEYW_OUTBOUND", "KEYW_UPON",
  "KEYW_HAVE_COMPONENTS", "KEYW_EXCLUDE", "KEYW_AFI", "KEYW_TUNNEL",
  "TKN_ERROR", "TKN_UNKNOWN_CLASS", "TKN_EOA", "TKN_EOO", "TKN_FREETEXT",
  "TKN_INT", "TKN_REAL", "TKN_STRING", "TKN_TIMESTAMP", "TKN_BLOB",
  "TKN_IPV4", "TKN_PRFXV4", "TKN_PRFXV4RNG", "TKN_IPV6", "TKN_PRFXV6",
  "TKN_PRFXV6RNG", "TKN_ASNO", "TKN_ASNAME", "TKN_RSNAME", "TKN_RTRSNAME",
  "TKN_PRNGNAME", "TKN_FLTRNAME", "TKN_BOOLEAN", "TKN_WORD", "TKN_RP_ATTR",
  "TKN_DNS", "TKN_EMAIL", "TKN_3DOTS", "TKN_AFI", "ATTR_GENERIC",
  "ATTR_BLOBS", "ATTR_REGEXP", "ATTR_IMPORT", "ATTR_MP_IMPORT",
  "ATTR_EXPORT", "ATTR_MP_EXPORT", "ATTR_DEFAULT", "ATTR_MP_DEFAULT",
  "ATTR_FREETEXT", "ATTR_CHANGED", "ATTR_IFADDR", "ATTR_INTERFACE",
  "ATTR_PEER", "ATTR_MP_PEER", "ATTR_INJECT", "ATTR_V6_INJECT",
  "ATTR_COMPONENTS", "ATTR_V6_COMPONENTS", "ATTR_AGGR_MTD",
  "ATTR_AGGR_BNDRY", "ATTR_RS_MEMBERS", "ATTR_RS_MP_MEMBERS",
  "ATTR_RTR_MP_MEMBERS", "ATTR_RP_ATTR", "ATTR_TYPEDEF", "ATTR_PROTOCOL",
  "ATTR_FILTER", "ATTR_V6_FILTER", "ATTR_MP_FILTER", "ATTR_MP_PEVAL",
  "ATTR_PEERING", "ATTR_MP_PEERING", "ATTR_ATTR", "ATTR_MNT_ROUTES",
  "ATTR_MNT_ROUTES6", "ATTR_MNT_ROUTES_MP", "OP_OR", "OP_AND", "OP_NOT",
  "OP_MS", "TKN_OPERATOR", "','", "'-'", "':'", "'{'", "'}'", "'('", "')'",
  "'.'", "';'", "'['", "']'", "'<'", "'>'", "'|'", "'*'", "'?'", "'+'",
  "'~'", "'^'", "'$'", "$accept", "object", "attribute_list", "attribute",
  "changed_attribute", "freetext_attribute", "regexp_attribute",
  "generic_attribute", "generic_list", "generic_non_empty_list",
  "blobs_attribute", "blobs_list", "list_item", "list_item_0", "tkn_word",
  "tkn_word_from_keyw", "opt_as_expr", "as_expr", "as_expr_term",
  "as_expr_factor", "as_expr_operand", "opt_router_expr",
  "opt_router_expr_with_at", "router_expr", "router_expr_term",
  "router_expr_factor", "router_expr_operand", "peering", "opt_action",
  "action", "single_action", "filter", "filter_term", "filter_factor",
  "filter_operand", "filter_prefix", "filter_prefix_operand",
  "opt_filter_prefix_list", "filter_prefix_list",
  "filter_prefix_list_prefix", "filter_aspath", "filter_aspath_term",
  "filter_aspath_closure", "filter_aspath_factor", "filter_aspath_no",
  "filter_aspath_range", "filter_rp_attribute",
  "import_peering_action_list", "export_peering_action_list",
  "import_factor", "import_factor_list", "export_factor",
  "export_factor_list", "import_term", "export_term", "import_expr",
  "export_expr", "opt_protocol_from", "opt_protocol_into",
  "mp_import_attribute", "mp_export_attribute", "mp_import_expr",
  "mp_export_expr", "mp_import_term", "mp_export_term", "mp_import_factor",
  "mp_import_factor_list", "mp_export_factor", "mp_export_factor_list",
  "mp_import_peering_action_list", "mp_export_peering_action_list",
  "mp_filter", "mp_filter_term", "mp_filter_factor", "mp_filter_operand",
  "mp_filter_prefix", "mp_filter_prefix_operand",
  "opt_mp_filter_prefix_list", "mp_filter_prefix_list",
  "mp_filter_prefix_list_prefix", "mp_peering", "opt_mp_router_expr",
  "opt_mp_router_expr_with_at", "mp_router_expr", "mp_router_expr_term",
  "mp_router_expr_factor", "mp_router_expr_operand", "import_attribute",
  "export_attribute", "opt_default_filter", "default_attribute",
  "mp_default_attribute", "opt_default_mp_filter", "filter_attribute",
  "mp_peval_attribute", "mp_peval", "mp_filter_attribute",
  "peering_attribute", "mp_peering_attribute", "ifaddr_attribute",
  "interface_address", "opt_tunnel_spec", "interface_attribute",
  "opt_peer_options", "peer_options", "peer_option", "peer_id",
  "peer_attribute", "mp_peer_attribute", "mp_peer_id",
  "v6_filter_attribute", "v6_filter", "v6_filter_term", "v6_filter_factor",
  "v6_filter_operand", "v6_filter_prefix", "v6_filter_prefix_operand",
  "opt_v6_filter_prefix_list", "v6_filter_prefix_list",
  "v6_filter_prefix_list_prefix", "v6_components_attribute",
  "v6_components_list", "v6_inject_attribute", "opt_v6_inject_expr",
  "v6_inject_expr", "v6_inject_expr_term", "v6_inject_expr_factor",
  "v6_inject_expr_operand", "aggr_bndry_attribute", "aggr_mtd_attribute",
  "opt_inject_expr", "inject_expr", "inject_expr_term",
  "inject_expr_factor", "inject_expr_operand", "inject_attribute",
  "opt_atomic", "components_list", "components_attribute",
  "opt_rs_members_list", "rs_members_list", "rs_member",
  "rs_members_attribute", "opt_rs_mp_members_list", "rs_mp_members_list",
  "rs_mp_member", "rs_mp_members_attribute", "rpattr_attribute", "methods",
  "method", "typedef_attribute", "typedef_type_list", "typedef_type",
  "enum_list", "protocol_attribute", "protocol_options", "protocol_option",
  "opt_attr_options", "attr_options", "attr_option", "attr_attribute",
  "mnt_routes_attribute", "mnt_routes_list", "mnt_routes_list_item",
  "mnt_routes6_attribute", "mnt_routes6_list", "mnt_routes6_list_item",
  "mnt_routes_mp_attribute", "mnt_routes_mp_list",
  "mnt_routes_mp_list_item", "opt_afi_list", "afi_list", "afi", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,    44,    45,    58,   123,
     125,    40,    41,    46,    59,    91,    93,    60,    62,   124,
      42,    63,    43,   126,    94,    36
};
# endif

#define YYPACT_NINF -674

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-674)))

#define YYTABLE_NINF -572

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    1261,   522,   178,   198,   919,   991,   236,    95,   235,   193,
     255,    83,    59,   252,    53,    62,    56,  1575,   294,   854,
     855,    60,    71,   302,   146,   760,   623,   250,   322,  1643,
      82,   211,   281,   274,    48,    98,  1711,  1843,  1843,  1843,
     104,  1329,  -674,  -674,  -674,  -674,  -674,  -674,  -674,  -674,
    -674,  -674,  -674,  -674,  -674,  -674,  -674,  -674,  -674,  -674,
    -674,  -674,  -674,  -674,  -674,  -674,  -674,  -674,  -674,  -674,
    -674,  -674,  -674,  -674,  -674,  -674,  -674,  -674,  -674,  -674,
    -674,  -674,  -674,   259,  -674,  -674,  -674,  -674,  -674,  -674,
    -674,  -674,  -674,  -674,  -674,  -674,  -674,  -674,  -674,  -674,
    -674,  -674,  -674,  -674,  -674,  -674,  -674,  -674,  -674,  -674,
    -674,  -674,  -674,  -674,  -674,  -674,  -674,  -674,  -674,  -674,
    -674,  -674,  -674,  -674,  -674,  -674,     1,  -674,  -674,  -674,
    -674,  -674,  -674,  -674,  -674,  -674,  -674,  -674,  -674,  -674,
     208,  -674,  1136,  1171,   264,   217,  -674,   240,  -674,   352,
    1064,  -674,  -674,   366,  1843,   384,   377,   384,   382,   384,
     399,   384,   409,   291,   426,   243,   482,  -674,   441,   471,
     454,    73,   458,  -674,  -674,    74,   483,  -674,  -674,  -674,
    -674,  -674,  -674,  -674,  -674,   308,  -674,   486,   400,   496,
     351,   543,   507,   455,   543,   516,  -674,  1171,   532,  1197,
     539,   452,   138,   546,  -674,  -674,   445,   168,    43,  -674,
    -674,   554,  -674,  -674,   490,   493,   517,   574,   537,  -674,
     601,  -674,  -674,  -674,  -674,   545,   551,   558,   615,   562,
    -674,   634,   268,   268,   640,   671,   644,   526,   646,  -674,
    -674,  -674,  -674,  -674,  -674,   548,  1171,   518,  1171,   369,
     314,   592,  -674,  -674,  -674,   611,  -674,   668,  -674,  -674,
    -674,  -674,  -674,  -674,  1197,   575,  1197,   369,  -674,   348,
     628,  -674,  -674,  -674,   631,   700,  -674,  -674,  -674,  -674,
    -674,  -674,  1207,   715,  1207,   369,  -674,   415,   639,  -674,
    -674,  -674,   663,   743,   243,   756,   758,  -674,   368,   768,
     778,  -674,   387,   783,   788,  1220,    37,    33,  -674,    42,
     197,  -674,    87,   215,  -674,  -674,   790,  -674,  -674,  -674,
     777,   795,   720,   498,  -674,  1136,  1136,  -674,  -674,  -674,
    -674,  -674,  1843,    57,  -674,   599,  -674,    64,  -674,   808,
    -674,   530,  -674,  -674,  -674,   741,  -674,   479,  -674,   811,
    -674,   814,   260,  -674,   815,   287,  -674,   828,  1439,  -674,
    -674,  -674,  1843,  -674,   831,  -674,  -674,  -674,  -674,  -674,
    1507,  -674,  -674,  -674,  -674,   351,   769,   114,  -674,  -674,
     310,   839,  -674,  -674,  -674,  -674,  -674,   455,   773,   115,
    -674,  -674,   845,  -674,   687,    32,  -674,   707,    41,  -674,
     840,  -674,   843,   846,   781,  -674,   -10,  -674,   445,   445,
     425,  -674,  -674,  -674,  -674,  -674,   701,  -674,  -674,  -674,
    -674,  -674,   847,  -674,   774,    50,    45,   313,  -674,   427,
    -674,   671,   879,    49,   775,   858,  -674,   864,   393,  -674,
    1136,  1136,   844,  1136,  -674,  -674,  -674,   793,   798,  -674,
     528,  -674,  -674,  -674,   369,  -674,   782,  -674,  -674,   572,
     369,   635,  -674,   784,  -674,  1171,   592,  1171,  -674,  -674,
    -674,  -674,  -674,   799,   802,  -674,   595,   584,  -674,  1197,
     628,  1197,  -674,  -674,  -674,  -674,  -674,  -674,  -674,   842,
     848,  -674,   633,   591,  -674,  1207,   639,  1207,  -674,  -674,
     725,  -674,  -674,   905,   769,  -674,  -674,   949,   773,  -674,
    -674,   229,   867,  -674,  -674,  -674,  -674,  -674,  -674,  -674,
    -674,  -674,   913,   849,  -674,  -674,   518,  -674,  1843,  -674,
     575,  -674,  1843,  -674,   715,  -674,  1843,  -674,  -674,  -674,
    -674,  -674,  -674,  -674,   291,   953,   590,    11,   719,   916,
     243,   920,   767,    70,   291,   959,   606,    12,   772,   944,
     243,   946,   780,    72,   984,  1017,   243,   580,  -674,  -674,
     986,   552,  -674,   987,   543,  -674,   988,   915,   990,   923,
    -674,  -674,  1013,  1016,   282,   351,   351,   501,   582,  -674,
     310,  -674,   111,  1018,   371,   455,   455,   459,   207,  1019,
    1843,  -674,   996,  -674,  -674,  -674,  -674,  -674,    43,  -674,
     445,  -674,  -674,  -674,  -674,   982,    46,   983,   283,  -674,
    -674,  -674,   992,  -674,   671,  1086,   671,  1057,  1777,  -674,
    -674,   268,   268,  -674,  -674,  -674,  1011,  1015,  1012,  -674,
     518,  -674,   175,  -674,   223,  -674,   369,   635,  -674,  -674,
    -674,   513,   592,  -674,  -674,   575,  -674,  -674,   628,  -674,
    -674,   715,  -674,  -674,   639,  -674,   770,  -674,  -674,  -674,
     841,   830,  -674,   841,   989,  -674,   993,  -674,  1056,  -674,
     543,  1053,    44,  1171,   291,  -674,  -674,    57,    57,  -674,
     149,  -674,  1094,  1094,   479,  1170,   157,   622,   543,  1055,
      76,  1171,   291,  -674,  -674,    64,    64,  -674,    61,  -674,
    1094,  1094,   479,  1172,   163,   659,  -674,  1171,  1133,  -674,
    1137,  1194,  -674,  1163,  1164,  -674,   216,  -674,  1136,  -674,
    1843,  -674,  -674,  -674,   114,  -674,   351,  -674,  1136,  1136,
    1144,  1136,  -674,  -674,  1095,  1096,   111,  1102,  1104,  -674,
    -674,  -674,  -674,   115,  -674,   455,  -674,  -674,  1098,  1100,
     207,  1109,  1110,  -674,  -674,  -674,  1171,  1197,  -674,  -674,
    1101,   671,  -674,  -674,   300,   671,  -674,   671,  -674,  1106,
    1111,  1112,  -674,   -39,  -674,  -674,  -674,  1136,  -674,  -674,
    -674,   232,  -674,  1108,  -674,  -674,  -674,   369,  -674,  -674,
    -674,  -674,  -674,  1113,  1114,  1116,  -674,  -674,  -674,  -674,
    -674,  -674,  -674,  1115,   687,   543,  1119,  -674,  -674,  1179,
    -674,    70,  -674,   543,  1120,    58,  -674,  -674,  1207,   479,
    -674,  -674,  -674,  1130,   687,   543,  1132,  -674,  -674,  1188,
    -674,    72,  -674,   543,  1140,    91,  -674,  -674,  1207,   479,
     687,  -674,  -674,  1207,  1189,  -674,  -674,  1218,   334,  1224,
    1150,  -674,  -674,  1151,  1152,  1156,  1153,   518,   518,   374,
     111,   111,  -674,   575,   575,   389,   207,   207,   687,   707,
    -674,   338,   658,  -674,  -674,  -674,  1228,  1230,  1231,  1843,
    -674,  1159,  -674,  1222,  1843,  1233,  -674,  -674,  -674,  -674,
    1162,  -674,  -674,  -674,  1165,   770,   543,  -674,  -674,  -674,
    1167,  -674,  -674,  -674,  1169,   770,   543,   770,  -674,  -674,
    1178,  -674,  -674,  -674,  1173,  1136,  1175,  1168,  1176,  -674,
    1104,  -674,  1180,  1181,  -674,  1110,  -674,   710,  -674,  1182,
    1161,  1177,  1183,  -674,  -674,  -674,  1186,   396,  -674,  -674,
    -674,  -674,  1227,  -674,  1190,  -674,  -674,  -674,  -674,  -674,
    1191,  -674,  1282,  -674,  -674,  -674,  1255,  -674,  -674,  1187,
    -674,   671,  1192,  -674,  -674,  -674
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     7,     0,     6,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     9,    14,    43,    13,    11,    12,    16,    18,
      15,    17,    19,    20,    36,    39,    38,    40,    41,    23,
      24,    21,    22,    37,    26,    28,    30,    29,    27,    25,
      34,    35,    33,    31,    32,    42,    44,    45,    46,    48,
       4,    47,     3,     0,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   126,
     127,   128,   129,   125,   130,   131,   132,   133,   134,   135,
     136,    66,    67,    68,    69,    88,    70,    71,    72,    73,
      74,    75,    65,    78,    79,    80,    81,    82,    83,    84,
      86,    87,    55,     0,     0,    56,    57,    63,    85,     0,
       0,    61,    52,     0,     0,   253,     0,   253,     0,   253,
       0,   253,     0,     0,     0,     0,     0,    51,     0,     0,
       0,     0,     0,   361,   362,     0,     0,    92,    93,    94,
      95,    96,    97,    98,    91,     0,    99,     0,     0,     0,
       0,   166,     0,     0,   166,     0,   459,   460,     0,   422,
       0,     0,     0,     0,   147,   148,     0,     0,   140,   144,
     146,     0,   475,   476,   469,   471,   473,     0,   466,   467,
       0,   489,   490,   491,   492,   483,   485,   487,     0,   480,
     481,     0,     0,     0,     0,     0,     0,     0,     0,   183,
     191,   190,   192,   193,   186,     0,     0,   195,     0,     0,
       0,   177,   179,   182,   187,   189,   185,     0,   402,   410,
     409,   411,   412,   405,     0,   414,     0,     0,   404,     0,
     396,   398,   401,   406,   408,     0,   291,   299,   298,   300,
     301,   294,     0,   303,     0,     0,   293,     0,   285,   287,
     290,   295,   297,     0,     0,     0,     0,   165,   149,     0,
       0,   312,   313,     0,     0,     0,   555,     0,   553,   561,
       0,   559,   567,     0,   565,     1,     0,     2,    10,    54,
       0,     0,     0,     0,    53,     0,     0,    60,    59,    62,
     331,   252,     0,     0,   258,   571,   334,     0,   262,   571,
     339,     0,   342,   575,   574,   570,   572,     0,    50,     0,
     360,     0,     0,   369,     0,     0,   382,     0,     0,   377,
     378,   376,   370,   386,     0,   387,   388,   390,   391,   389,
       0,   457,   161,   163,   162,     0,   152,   154,   158,   160,
       0,   445,   426,   325,   326,   328,   327,     0,   316,   318,
     322,   324,   427,   464,   461,     0,   421,   423,     0,   444,
       0,   440,     0,     0,   138,   439,     0,   438,     0,     0,
       0,   478,   470,   472,   474,   477,     0,   494,   484,   486,
     488,   493,     0,   497,     0,     0,     0,     0,   498,     0,
     510,     0,     0,     0,   515,     0,   526,     0,     0,   346,
       0,    55,     0,    55,   180,   199,   200,     0,   196,   197,
       0,   216,   215,   217,     0,   218,   221,   211,   212,     0,
     202,   204,   210,   214,   345,     0,   176,     0,   188,   393,
     399,   418,   419,     0,   415,   416,     0,     0,   392,     0,
     395,     0,   407,   351,   288,   309,   310,   307,   308,     0,
     304,   305,     0,     0,   350,     0,   284,     0,   296,   348,
       0,   347,   353,   151,   150,   352,   355,   315,   314,   354,
     551,     0,     0,   540,   541,   548,   543,   544,   545,   546,
     542,   547,     0,   532,   533,   556,   195,   552,     0,   562,
     414,   558,     0,   568,   303,   564,     0,    76,    77,    89,
      90,    58,    64,   254,     0,     0,     0,     0,   245,     0,
       0,     0,   263,     0,     0,     0,     0,     0,   248,     0,
       0,     0,   266,     0,     0,   335,     0,     0,    49,   359,
       0,     0,   368,     0,   166,   381,     0,     0,     0,   371,
     372,   385,     0,     0,     0,     0,     0,     0,     0,   174,
     167,   168,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   463,     0,   420,   443,   442,   441,   145,   139,   142,
       0,   141,   468,   482,   508,     0,     0,     0,     0,   495,
     499,   496,   513,   511,     0,     0,     0,     0,     0,   509,
     525,     0,     0,   524,   528,   228,     0,     0,     0,   194,
       0,   181,     0,   221,     0,   184,     0,   203,   205,   206,
     207,     0,   175,   178,   413,     0,   400,   403,   394,   397,
     302,     0,   289,   292,   283,   286,   349,   164,   311,   550,
       0,     0,   549,     0,     0,   554,     0,   560,     0,   566,
     166,     0,     0,     0,     0,   330,   241,     0,     0,   329,
       0,   255,   571,   571,     0,     0,     0,     0,   166,     0,
       0,     0,     0,   333,   243,     0,     0,   332,     0,   259,
     571,   571,     0,     0,     0,     0,   338,     0,     0,   573,
       0,   343,   358,     0,     0,   367,     0,   380,    55,   379,
       0,   384,   383,   159,   153,   156,     0,   155,     0,    55,
       0,    55,   169,   453,     0,     0,     0,   446,   448,   450,
     452,   456,   323,   317,   320,     0,   319,   435,     0,     0,
       0,   428,   430,   432,   434,   425,     0,     0,   143,   507,
       0,     0,   505,   500,     0,     0,   514,     0,   520,     0,
       0,     0,   522,     0,   530,   529,   229,    55,   230,   198,
     213,     0,   223,   222,   226,   224,   219,   201,   209,   208,
     417,   306,   535,     0,     0,     0,   534,   557,   563,   569,
     231,   236,   242,     0,   235,   166,     0,   246,   247,     0,
     264,     0,   265,   166,     0,     0,   256,   269,     0,     0,
     233,   239,   244,     0,   238,   166,     0,   249,   250,     0,
     267,     0,   268,   166,     0,     0,   260,   271,     0,     0,
     336,   337,   341,     0,     0,   357,   356,     0,     0,     0,
       0,   373,   157,     0,     0,     0,     0,   195,   195,     0,
       0,     0,   321,   414,   414,     0,     0,     0,   462,   424,
     506,     0,     0,   501,   512,   521,     0,     0,     0,     0,
     518,     0,   220,     0,     0,     0,   536,   237,   232,   257,
       0,   279,   274,   270,     0,   273,   166,   240,   234,   261,
       0,   281,   277,   272,     0,   276,   166,   344,   340,   366,
       0,   365,   374,   171,     0,    55,     0,     0,     0,   451,
     447,   449,     0,     0,   433,   429,   431,     0,   503,     0,
       0,     0,     0,   523,   227,   225,     0,     0,   275,   280,
     278,   282,     0,   172,     0,   173,   454,   455,   436,   437,
       0,   502,     0,   516,   517,   537,     0,   538,   364,     0,
     504,     0,     0,   170,   519,   539
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -674,  -674,  -674,  1274,  -674,  -674,  -674,  -674,  -136,  -674,
    -674,  -674,     4,   995,   -12,    -4,  -674,   -20,   909,  -368,
    -674,  -674,   816,   -67,   737,  -543,  -674,  -147,  -183,  -674,
     733,  -133,  -232,  -215,  -674,  -674,  -674,  -498,  -674,   685,
    -230,   681,  -431,  -674,  -674,   688,   -29,  -674,  -674,  -311,
    -674,  -314,  -674,  -674,  -674,   123,    96,   787,   451,  -674,
    -674,   120,   132,  -674,  -674,  -650,  -674,  -673,  -674,  -674,
    -674,  -270,  -279,  -250,  -674,  -674,  -674,   824,  -674,   672,
    -327,  -674,   825,  -182,   785,  -558,  -674,  -674,  -674,  -674,
    -674,  -674,  -674,  -674,  -674,  -674,  -674,  -674,  -674,  -674,
     514,  -674,  -674,  1003,  -674,   645,  -674,  -674,  -674,  -674,
    -674,  -180,  -256,  -231,  -674,  -674,  -674,  -509,  -674,   721,
    -674,  -674,  -674,  -674,   618,   503,   504,  -674,  -674,  -674,
    -674,   636,   515,   512,  -674,  -674,  1362,  -674,  -674,  -674,
    -674,   970,  -674,  -674,  -674,   965,  -674,  -674,  1155,  -393,
    -674,  -583,  -228,  -674,  -674,  -674,  -674,  -674,  -674,  -190,
    -674,  -674,  -674,   861,  -674,  -674,   859,  -674,  -674,   856,
       0,  -264,   827
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    40,    41,    42,    43,    44,    45,    46,   144,   145,
      47,   150,   146,   147,   577,   186,   403,   298,   208,   209,
     210,   503,   191,   376,   377,   378,   379,   299,   381,   590,
     591,   250,   251,   252,   253,   254,   255,   447,   448,   449,
     459,   460,   461,   462,   463,   644,   256,   546,   556,   816,
     682,   836,   700,   548,   558,   549,   559,   155,   333,    48,
      49,   551,   561,   552,   562,   696,   825,   714,   845,   697,
     715,   287,   288,   289,   290,   291,   292,   489,   490,   491,
     303,   507,   194,   388,   389,   390,   391,    50,    51,   718,
      52,    53,   854,    54,    55,   295,    56,    57,    58,    59,
     175,   859,    60,   578,   579,   580,   362,    61,    62,   370,
      63,   269,   270,   271,   272,   273,   274,   473,   474,   475,
      64,   398,    65,   599,   761,   762,   763,   764,    66,    67,
     593,   747,   748,   749,   750,    68,   197,   395,    69,   217,
     218,   219,    70,   228,   229,   230,    71,    72,   427,   428,
      73,   622,   623,   783,    74,   438,   634,   522,   523,   524,
      75,    76,   307,   308,    77,   310,   311,    78,   313,   314,
     821,   345,   346
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     148,   148,   268,   286,   207,   185,   322,   435,   496,   151,
     323,   392,   166,   480,   492,   302,   341,   237,   466,   397,
     567,   676,   547,   557,   305,   306,   309,   312,   674,   647,
     500,   444,   484,   470,   620,   774,   620,   477,   754,   756,
     844,   609,   611,   735,   737,   824,   617,   770,   525,   296,
     625,   615,   544,   529,   168,   493,   409,   172,   685,   703,
     164,   195,   839,   170,   394,   544,   694,   600,  -571,   626,
    -570,  -458,   198,   554,   351,   354,   602,   889,   694,   601,
     527,   712,  -458,   238,   162,   554,   476,   890,   603,   352,
     355,   466,   163,   239,  -458,  -458,   153,   196,   533,   300,
     712,   408,   165,  -251,   315,  -458,  -458,  -458,   196,   204,
     205,   173,   607,   297,   174,   450,   240,   171,  -458,   320,
     508,  -458,  -458,  -458,   169,   743,  -458,   586,   596,  -458,
     154,  -251,  -458,  -458,  -458,   686,   704,  -458,   148,   402,
    -458,   480,   331,   241,   242,   243,   148,   203,   244,   528,
     819,   245,   744,   745,   329,   410,   526,  -570,   565,   204,
     205,   530,   466,   301,   812,   616,   618,   771,   910,   206,
     268,   900,   914,  -458,   627,   904,   545,   566,   903,  -458,
    -570,  -458,   404,   555,  -458,  -137,   406,  -458,   881,   695,
    -458,   713,  -458,   862,   158,   246,   832,   872,  -458,   204,
     205,   247,  -251,   248,   826,   594,   534,   204,   205,   249,
     846,   913,   257,   496,  -251,   407,   664,   857,   466,   206,
     480,   757,   258,   658,   642,    81,   587,   597,   154,  -251,
     666,   504,   746,   652,   681,   268,   156,   268,   784,   785,
     268,   699,   768,  -251,   531,   259,    82,   665,   758,   759,
     659,   231,   653,   286,   343,   286,   160,   792,   286,   206,
     858,   570,   535,  -363,  -251,   566,   792,   206,  -570,   424,
     154,  -251,   260,   261,   262,   293,   669,   263,  -251,   408,
     245,   827,   275,   152,   793,   794,   690,   847,   573,   425,
     154,  -251,   276,   793,   794,   187,   708,   790,  -251,   167,
     431,   432,   433,   200,   646,   636,   319,   638,   584,   357,
     571,   324,  -251,   532,   424,   277,   344,   294,   232,   233,
     543,   148,   148,   234,   264,   239,   321,   302,   760,   541,
     265,   536,   266,   325,   425,   553,   426,   574,   267,   563,
     201,   202,   278,   279,   280,   670,   795,   281,   240,   796,
     245,   434,   204,   205,  -251,   795,   297,   326,   892,   258,
     619,   464,   188,   358,   932,   933,   647,   823,   268,   927,
     928,   813,   359,   360,  -251,   241,   242,   243,   361,   588,
     244,   426,   259,   245,   721,   843,   833,   496,   724,   173,
     235,   726,   174,   585,   282,   478,   776,   680,   778,   327,
     283,   364,   284,   451,   733,   773,   372,   698,   285,   260,
     261,   262,   206,   330,   263,   373,   882,   245,   631,   632,
     332,   374,   883,   372,   334,   465,   276,   246,   424,   336,
     452,   453,   373,   247,   589,   248,   148,   148,   374,   148,
     633,   249,   383,   805,   635,   384,   338,   268,   425,   277,
     268,   385,   268,   400,   937,   365,   340,   386,   366,   479,
     938,   264,   494,   286,   367,   368,   286,   265,   286,   266,
     369,   286,   375,   342,   621,   267,   278,   279,   280,   408,
     802,   281,   595,   806,   245,   870,   204,   205,   348,   375,
     454,   347,   455,   752,   456,   426,   929,   810,   408,   401,
     876,   350,   906,   457,   458,   353,   204,   205,   387,   239,
     383,   934,   966,   384,   383,   830,   306,   384,   967,   385,
     309,   349,   916,   385,   312,   386,   495,   437,   282,   386,
     356,   564,   240,   363,   283,   380,   284,   815,   610,   239,
     204,   205,   285,   371,   301,  -166,   206,   884,   380,   885,
     814,  -527,  -527,   723,   382,   835,   372,   380,   905,   241,
     242,   243,   240,   393,   244,   373,   206,   245,   834,    79,
      80,   374,   755,  -527,   445,   446,   387,  -166,   915,   396,
     387,   720,   466,   917,   850,   380,   399,   879,   766,   241,
     242,   243,   860,   405,   244,  -166,   683,   245,   684,  -166,
     206,   411,   466,   864,   412,   866,   258,   413,   335,   465,
     337,   246,   339,   701,   736,   702,   782,   247,   466,   248,
     540,   415,   375,   480,   220,   249,   496,  -166,   828,   259,
     829,   414,   898,   878,   471,   472,   496,   286,   496,   465,
     901,   246,   550,   798,   276,   799,   466,   247,   417,   248,
     641,   891,   908,   416,   884,   249,   260,   261,   262,   418,
     911,   263,   421,   440,   245,   419,   848,   277,   849,   441,
    -479,   442,   420,   443,   302,   431,   432,   433,   422,   221,
     222,   423,   223,   224,   225,   226,   227,   430,   431,   432,
     433,   436,   302,   439,   278,   279,   280,   738,   239,   281,
     645,   646,   245,   739,   467,   740,   479,   741,   264,   884,
     841,   841,   657,   646,   265,   469,   266,   656,   258,   663,
     646,   240,   267,   949,   148,   468,   434,   431,   432,   433,
     939,   687,   688,   951,   148,   148,   276,   148,   268,   434,
     481,   259,   863,   974,   495,   482,   282,   483,   241,   242,
     243,   497,   283,   244,   284,   662,   245,   212,   213,   277,
     285,   211,   214,   215,   216,   648,   649,   650,   260,   261,
     262,   485,   486,   263,   487,   488,   245,   498,   434,   692,
     693,   276,   960,   148,   705,   706,   278,   279,   280,   954,
     499,   281,   710,   711,   245,   157,   159,   161,   465,   286,
     246,   837,   838,   501,   277,   502,   247,  -465,   248,   302,
     817,   818,   820,   822,   249,   505,   212,   213,   479,   286,
     264,   214,   215,   216,   286,   506,   265,   537,   266,   302,
     509,   278,   279,   280,   267,   510,   281,    79,   282,   245,
     539,   566,   840,   842,   283,   538,   284,   431,   432,   433,
     268,   560,   285,   803,   804,   189,   192,   566,   568,  -151,
    -315,   569,   572,   512,   190,   193,   513,   514,   515,   516,
     517,   518,   519,   520,   521,   575,   286,   943,   581,   592,
     585,   495,   946,   282,   595,   598,   286,   604,   286,   283,
     605,   284,   408,   606,  -151,  -315,   614,   285,   434,   624,
     628,  -151,  -315,   221,   222,   629,   223,   224,   225,   226,
     227,   630,   637,   639,   640,   190,   643,   651,   655,   654,
      83,   148,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   193,
     672,   544,   660,   689,   661,   673,   -55,   691,   554,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   671,   140,
     141,   707,   149,   709,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   716,   717,   722,   725,   727,   728,   729,   142,   730,
     143,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     731,   140,   141,   732,   767,   751,   765,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   769,   772,   777,   779,   775,   807,
     142,   328,   143,   808,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   786,   140,   141,   787,   165,   788,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   809,   811,   694,   831,
     851,   712,   239,   142,   852,   143,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   240,   140,   141,   258,   853,
     855,   856,   865,   870,   867,   868,   871,   873,   276,   874,
     876,   511,   877,   880,   886,   893,   899,   887,   888,   894,
     895,   259,   241,   242,   243,   909,   918,   244,   896,   897,
     245,   277,   512,   686,   902,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   907,   142,   704,   143,   260,   261,
     262,    -8,     1,   263,   912,   919,   245,  -531,   278,   279,
     280,   921,   922,   281,   924,   923,   245,   925,   940,   926,
     941,   944,   942,   945,   246,   947,   827,   962,   956,   948,
     247,   847,   248,   950,   952,   968,   957,   953,   249,   955,
     958,   959,   971,   963,   961,   972,     2,     3,   965,   964,
     264,   973,   969,   970,   975,   318,   265,   608,   266,   667,
     282,   542,   734,   742,   267,   789,   283,   797,   284,    -5,
     316,   791,   668,   801,   285,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,   678,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,   920,   583,     2,   861,   800,   317,   875,   935,
     753,   936,   869,   931,   199,   930,   612,   613,   429,   675,
       0,   677,   679,   719,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,     0,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
     576,     0,  -375,  -375,  -375,  -375,  -375,  -375,  -375,  -375,
    -375,  -375,  -375,  -375,  -375,  -375,  -375,  -375,  -375,  -375,
    -375,  -375,  -375,  -375,  -375,  -375,  -375,  -375,  -375,  -375,
    -375,  -375,  -375,  -375,  -375,  -375,  -375,  -375,  -375,     0,
       0,     0,     0,     0,     0,     0,  -375,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    -375,  -375,  -375,  -375,  -375,  -375,  -375,  -375,   582,     0,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,     0,     0,     0,
       0,     0,     0,     0,  -370,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   177,   178,
     179,   180,   181,   182,   183,   184,   176,     0,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   177,   178,   179,   180,
     181,   182,   183,   184,   236,     0,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   177,   178,   179,   180,   181,   182,
     183,   184,   304,     0,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   177,   178,   179,   180,   181,   182,   183,   184,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   780,   781,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   177,   178,
     179,   180,   181,   182,   183,   184,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   177,   178,   179,   180,   181,   182,
     183,   184
};

static const yytype_int16 yycheck[] =
{
       4,     5,    31,    32,    24,    17,   142,   235,   287,     5,
     143,   194,    12,   269,   284,    35,   163,    29,   250,   199,
     347,   530,   333,   337,    36,    37,    38,    39,   526,   460,
     294,   246,   282,   264,   427,   618,   429,   267,   596,   597,
     713,   409,   410,   586,   587,   695,     1,     1,    11,     1,
       1,     1,     8,    11,     1,   285,    13,     1,    47,    47,
       1,     1,     1,     1,   197,     8,     8,    35,     9,    20,
       9,    11,     1,     9,     1,     1,    35,   116,     8,    47,
      47,     9,    11,     1,     1,     9,   266,   126,    47,    16,
      16,   323,     9,    11,    34,    35,     1,    37,    11,     1,
       9,   111,    43,     8,     0,    34,    35,    47,    37,    61,
      62,    55,   122,    65,    58,   248,    34,    55,    47,   118,
     302,    61,    62,    63,    71,    14,    66,    13,    13,    69,
      35,    36,    61,    62,    63,   124,   124,    66,   142,     1,
      69,   397,   154,    61,    62,    63,   150,     1,    66,   116,
       1,    69,    41,    42,   150,   112,   119,     8,   341,    61,
      62,   119,   394,    65,   120,   115,   121,   121,   841,   121,
     199,   821,   845,   113,   125,   825,   119,   116,   120,   119,
     119,   121,   202,   119,   113,    47,   206,   127,   771,   119,
     119,   119,   121,   736,     1,   113,   120,   755,   127,    61,
      62,   119,     9,   121,    47,   387,   119,    61,    62,   127,
      47,   120,     1,   492,   119,    47,   495,     1,   450,   121,
     476,    14,    11,   479,   454,    47,   112,   112,    35,    36,
     500,   298,   121,   465,   545,   264,     1,   266,   631,   632,
     269,   555,   610,     8,    47,    34,    48,   497,    41,    42,
     481,     1,   467,   282,    11,   284,     1,    34,   287,   121,
      44,     1,    47,    47,     9,   116,    34,   121,   119,     1,
      35,    36,    61,    62,    63,     1,    47,    66,    43,   111,
      69,   124,     1,    47,    61,    62,   550,   124,     1,    21,
      35,    36,    11,    61,    62,     1,   560,   122,    43,    47,
      17,    18,    19,     1,   129,   441,    47,   443,   375,     1,
      50,    47,   119,   116,     1,    34,    73,    43,    68,    69,
     332,   325,   326,     1,   113,    11,   118,   347,   121,   325,
     119,   116,   121,   116,    21,   335,    68,    50,   127,   339,
      38,    39,    61,    62,    63,   116,   123,    66,    34,   126,
      69,    68,    61,    62,   119,   123,    65,   117,   126,    11,
      47,    47,    68,    55,   873,   874,   797,   694,   397,   867,
     868,   682,    64,    65,   119,    61,    62,    63,    70,    69,
      66,    68,    34,    69,   567,   712,   700,   666,   571,    55,
      68,   574,    58,   111,   113,    47,   624,   544,   626,    47,
     119,     1,   121,    34,   122,   122,    55,   554,   127,    61,
      62,    63,   121,    47,    66,    64,   116,    69,    25,    26,
      36,    70,   122,    55,    47,   111,    11,   113,     1,    47,
      61,    62,    64,   119,   124,   121,   440,   441,    70,   443,
      47,   127,    55,   671,   440,    58,    47,   476,    21,    34,
     479,    64,   481,     1,   116,    55,    47,    70,    58,   111,
     122,   113,    47,   492,    64,    65,   495,   119,   497,   121,
      70,   500,   121,    47,    47,   127,    61,    62,    63,   111,
     670,    66,   111,   673,    69,   111,    61,    62,    47,   121,
     121,     9,   123,   122,   125,    68,   122,   680,   111,    47,
     111,    47,   829,   134,   135,    47,    61,    62,   121,    11,
      55,   122,   116,    58,    55,   698,   528,    58,   122,    64,
     532,    50,   849,    64,   536,    70,   111,     1,   113,    70,
      47,     1,    34,    47,   119,     5,   121,   684,   113,    11,
      61,    62,   127,    47,    65,    15,   121,   775,     5,   777,
     683,    25,    26,     1,    47,   702,    55,     5,   828,    61,
      62,    63,    34,    47,    66,    64,   121,    69,   701,    47,
      48,    70,   113,    47,    56,    57,   121,    47,   848,    47,
     121,     1,   814,   853,   717,     5,    47,   767,   600,    61,
      62,    63,   728,    47,    66,    15,     6,    69,     8,    47,
     121,    47,   834,   739,   114,   741,    11,   114,   157,   111,
     159,   113,   161,     7,   113,     9,   628,   119,   850,   121,
     122,    47,   121,   879,     1,   127,   905,    47,     6,    34,
       8,   114,   815,   766,    59,    60,   915,   666,   917,   111,
     823,   113,    43,   130,    11,   132,   878,   119,    47,   121,
     122,   787,   835,   116,   882,   127,    61,    62,    63,   114,
     843,    66,    47,   115,    69,   114,     7,    34,     9,   121,
      47,   123,   114,   125,   694,    17,    18,    19,   116,    56,
      57,    47,    59,    60,    61,    62,    63,    47,    17,    18,
      19,    47,   712,    47,    61,    62,    63,   115,    11,    66,
     128,   129,    69,   121,   112,   123,   111,   125,   113,   937,
     710,   711,   128,   129,   119,    47,   121,   122,    11,   128,
     129,    34,   127,   906,   728,   114,    68,    17,    18,    19,
      72,    12,    13,   916,   738,   739,    11,   741,   767,    68,
     112,    34,   738,   971,   111,   114,   113,    47,    61,    62,
      63,   112,   119,    66,   121,   122,    69,    56,    57,    34,
     127,     1,    61,    62,    63,   130,   131,   132,    61,    62,
      63,    56,    57,    66,    59,    60,    69,   114,    68,    12,
      13,    11,    72,   787,    12,    13,    61,    62,    63,   925,
      47,    66,    12,    13,    69,     8,     9,    10,   111,   828,
     113,   705,   706,    47,    34,    47,   119,    47,   121,   829,
     687,   688,   692,   693,   127,    47,    56,    57,   111,   848,
     113,    61,    62,    63,   853,    47,   119,    50,   121,   849,
      47,    61,    62,    63,   127,    47,    66,    47,   113,    69,
     120,   116,   710,   711,   119,    50,   121,    17,    18,    19,
     879,    43,   127,    23,    24,     1,     1,   116,    47,     5,
       5,    47,    47,    22,    10,    10,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    47,   905,   889,    47,    40,
     111,   111,   894,   113,   111,    40,   915,    47,   917,   119,
      47,   121,   111,    47,    40,    40,   122,   127,    68,    20,
     125,    47,    47,    56,    57,    47,    59,    60,    61,    62,
      63,    47,    68,   120,   116,    10,   134,   133,   116,   120,
       1,   925,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    10,
      47,     8,   120,    47,   116,   116,    47,    47,     9,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,   121,    70,
      71,    47,     1,    47,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    47,    15,    47,    47,    47,   121,    47,   119,   116,
     121,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      47,    70,    71,    47,    68,    47,    47,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,   122,   122,    20,    50,   116,   120,
     119,    47,   121,   120,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,   122,    70,    71,   121,    43,   126,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,   120,   124,     8,   124,
      47,     9,    11,   119,    47,   121,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    34,    70,    71,    11,    15,
      47,    47,    68,   111,   119,   119,   112,   119,    11,   119,
     111,     1,   112,   122,   118,   117,    47,   116,   116,   116,
     116,    34,    61,    62,    63,    47,    47,    66,   122,   124,
      69,    34,    22,   124,   124,    25,    26,    27,    28,    29,
      30,    31,    32,    33,   124,   119,   124,   121,    61,    62,
      63,     0,     1,    66,   124,    47,    69,    47,    61,    62,
      63,    47,   122,    66,   122,   124,    69,   121,    50,   126,
      50,   122,    51,    61,   113,    52,   124,   126,   120,   124,
     119,   124,   121,   124,   116,    68,   120,   124,   127,   124,
     120,   120,    20,   126,   122,    50,    45,    46,   122,   126,
     113,   124,   122,   122,   122,    41,   119,   408,   121,   503,
     113,   326,   585,   590,   127,   640,   119,   646,   121,     0,
       1,   643,   507,   661,   127,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,   534,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   858,   370,    45,   730,   655,    48,   760,   876,
     595,   877,   746,   871,    22,   870,   416,   422,   233,   528,
      -1,   532,   536,   566,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    -1,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    47,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      61,    62,    63,    64,    65,    66,    67,    68,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    47,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,    62,
      63,    64,    65,    66,    67,    68,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    61,    62,    63,    64,
      65,    66,    67,    68,     1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    61,    62,    63,    64,    65,    66,
      67,    68,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    61,    62,    63,    64,    65,    66,    67,    68,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,    51,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,    62,
      63,    64,    65,    66,    67,    68,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    61,    62,    63,    64,    65,    66,
      67,    68
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     1,    45,    46,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     137,   138,   139,   140,   141,   142,   143,   146,   195,   196,
     223,   224,   226,   227,   229,   230,   232,   233,   234,   235,
     238,   243,   244,   246,   256,   258,   264,   265,   271,   274,
     278,   282,   283,   286,   290,   296,   297,   300,   303,    47,
      48,    47,    48,     1,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      70,    71,   119,   121,   144,   145,   148,   149,   151,     1,
     147,   148,    47,     1,    35,   193,     1,   193,     1,   193,
       1,   193,     1,     9,     1,    43,   306,    47,     1,    71,
       1,    55,     1,    55,    58,   236,     1,    61,    62,    63,
      64,    65,    66,    67,    68,   150,   151,     1,    68,     1,
      10,   158,     1,    10,   218,     1,    37,   272,     1,   272,
       1,    38,    39,     1,    61,    62,   121,   153,   154,   155,
     156,     1,    56,    57,    61,    62,    63,   275,   276,   277,
       1,    56,    57,    59,    60,    61,    62,    63,   279,   280,
     281,     1,    68,    69,     1,    68,     1,   150,     1,    11,
      34,    61,    62,    63,    66,    69,   113,   119,   121,   127,
     167,   168,   169,   170,   171,   172,   182,     1,    11,    34,
      61,    62,    63,    66,   113,   119,   121,   127,   182,   247,
     248,   249,   250,   251,   252,     1,    11,    34,    61,    62,
      63,    66,   113,   119,   121,   127,   182,   207,   208,   209,
     210,   211,   212,     1,    43,   231,     1,    65,   153,   163,
       1,    65,   153,   216,     1,   150,   150,   298,   299,   150,
     301,   302,   150,   304,   305,     0,     1,    48,   139,    47,
     118,   118,   144,   167,    47,   116,   117,    47,    47,   148,
      47,   150,    36,   194,    47,   194,    47,   194,    47,   194,
      47,   163,    47,    11,    73,   307,   308,     9,    47,    50,
      47,     1,    16,    47,     1,    16,    47,     1,    55,    64,
      65,    70,   242,    47,     1,    55,    58,    64,    65,    70,
     245,    47,    55,    64,    70,   121,   159,   160,   161,   162,
       5,   164,    47,    55,    58,    64,    70,   121,   219,   220,
     221,   222,   164,    47,   167,   273,    47,   247,   257,    47,
       1,    47,     1,   152,   153,    47,   153,    47,   111,    13,
     112,    47,   114,   114,   114,    47,   116,    47,   114,   114,
     114,    47,   116,    47,     1,    21,    68,   284,   285,   284,
      47,    17,    18,    19,    68,   288,    47,     1,   291,    47,
     115,   121,   123,   125,   169,    56,    57,   173,   174,   175,
     167,    34,    61,    62,   121,   123,   125,   134,   135,   176,
     177,   178,   179,   180,    47,   111,   168,   112,   114,    47,
     249,    59,    60,   253,   254,   255,   247,   176,    47,   111,
     248,   112,   114,    47,   209,    56,    57,    59,    60,   213,
     214,   215,   207,   176,    47,   111,   208,   112,   114,    47,
     307,    47,    47,   157,   159,    47,    47,   217,   219,    47,
      47,     1,    22,    25,    26,    27,    28,    29,    30,    31,
      32,    33,   293,   294,   295,    11,   119,    47,   116,    11,
     119,    47,   116,    11,   119,    47,   116,    50,    50,   120,
     122,   148,   149,   150,     8,   119,   183,   185,   189,   191,
      43,   197,   199,   306,     9,   119,   184,   187,   190,   192,
      43,   198,   200,   306,     1,   164,   116,   216,    47,    47,
       1,    50,    47,     1,    50,    47,     1,   150,   239,   240,
     241,    47,     1,   239,   159,   111,    13,   112,    69,   124,
     165,   166,    40,   266,   219,   111,    13,   112,    40,   259,
      35,    47,    35,    47,    47,    47,    47,   122,   154,   155,
     113,   155,   277,   281,   122,     1,   115,     1,   121,    47,
     285,    47,   287,   288,    20,     1,    20,   125,   125,    47,
      47,    25,    26,    47,   292,   148,   144,    68,   144,   120,
     116,   122,   176,   134,   181,   128,   129,   178,   130,   131,
     132,   133,   168,   169,   120,   116,   122,   128,   248,   249,
     120,   116,   122,   128,   208,   209,   207,   158,   218,    47,
     116,   121,    47,   116,   173,   299,   253,   302,   213,   305,
     163,   185,   186,     6,     8,    47,   124,    12,    13,    47,
     307,    47,    12,    13,     8,   119,   201,   205,   163,   187,
     188,     7,     9,    47,   124,    12,    13,    47,   307,    47,
      12,    13,     9,   119,   203,   206,    47,    15,   225,   308,
       1,   164,    47,     1,   164,    47,   164,    47,   121,    47,
     116,    47,    47,   122,   160,   161,   113,   161,   115,   121,
     123,   125,   166,    14,    41,    42,   121,   267,   268,   269,
     270,    47,   122,   220,   221,   113,   221,    14,    41,    42,
     121,   260,   261,   262,   263,    47,   150,    68,   155,   122,
       1,   121,   122,   122,   287,   116,   288,    20,   288,    50,
      50,    51,   150,   289,   285,   285,   122,   121,   126,   175,
     122,   181,    34,    61,    62,   123,   126,   177,   130,   132,
     255,   215,   295,    23,    24,   288,   295,   120,   120,   120,
     164,   124,   120,   185,   167,   163,   185,   191,   191,     1,
     197,   306,   197,   216,   201,   202,    47,   124,     6,     8,
     164,   124,   120,   187,   167,   163,   187,   192,   192,     1,
     198,   306,   198,   216,   203,   204,    47,   124,     7,     9,
     167,    47,    47,    15,   228,    47,    47,     1,    44,   237,
     144,   241,   161,   148,   144,    68,   144,   119,   119,   267,
     111,   112,   221,   119,   119,   260,   111,   112,   167,   247,
     122,   287,   116,   122,   288,   288,   118,   116,   116,   116,
     126,   144,   126,   117,   116,   116,   122,   124,   164,    47,
     201,   164,   124,   120,   201,   207,   216,   124,   164,    47,
     203,   164,   124,   120,   203,   207,   216,   207,    47,    47,
     236,    47,   122,   124,   122,   121,   126,   173,   173,   122,
     268,   269,   253,   253,   122,   261,   262,   116,   122,    72,
      50,    50,    51,   150,   122,    61,   150,    52,   124,   164,
     124,   164,   116,   124,   144,   124,   120,   120,   120,   120,
      72,   122,   126,   126,   126,   122,   116,   122,    68,   122,
     122,    20,    50,   124,   288,   122
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   136,   137,   137,   137,   137,   137,   137,   137,   138,
     138,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   139,   139,   140,
     140,   141,   142,   143,   143,   144,   144,   145,   145,   146,
     146,   147,   147,   148,   148,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   150,   150,   150,   150,   150,   150,   150,   150,   150,
     151,   151,   151,   151,   151,   151,   151,   151,   151,   151,
     151,   151,   151,   151,   151,   151,   151,   151,   151,   151,
     151,   151,   151,   151,   151,   151,   151,   151,   151,   151,
     151,   151,   151,   151,   151,   151,   151,   152,   152,   153,
     153,   154,   154,   154,   154,   155,   155,   156,   156,   157,
     157,   158,   158,   159,   159,   160,   160,   160,   160,   161,
     161,   162,   162,   162,   163,   163,   164,   164,   165,   165,
     166,   166,   166,   166,   166,   167,   167,   167,   168,   168,
     169,   169,   169,   170,   170,   170,   170,   170,   171,   171,
     172,   172,   172,   172,   172,   173,   173,   174,   174,   175,
     175,   176,   176,   177,   177,   178,   178,   178,   178,   178,
     178,   179,   179,   179,   179,   180,   180,   180,   180,   180,
     180,   181,   181,   181,   181,   181,   181,   182,   182,   182,
     182,   183,   183,   184,   184,   185,   186,   186,   187,   188,
     188,   189,   189,   190,   190,   191,   191,   191,   192,   192,
     192,   193,   193,   194,   194,   195,   195,   195,   195,   196,
     196,   196,   196,   197,   197,   197,   198,   198,   198,   199,
     199,   200,   200,   201,   202,   202,   203,   204,   204,   205,
     205,   206,   206,   207,   207,   207,   208,   208,   209,   209,
     209,   210,   210,   210,   210,   210,   211,   211,   212,   212,
     212,   212,   212,   213,   213,   214,   214,   215,   215,   215,
     215,   216,   216,   217,   217,   218,   218,   219,   219,   220,
     220,   220,   220,   221,   221,   222,   222,   222,   222,   223,
     223,   223,   224,   224,   224,   225,   225,   226,   226,   226,
     227,   227,   227,   228,   228,   229,   229,   230,   230,   231,
     232,   232,   233,   233,   234,   234,   235,   235,   235,   235,
     235,   236,   236,   237,   237,   238,   238,   238,   238,   238,
     239,   239,   240,   240,   241,   242,   242,   242,   242,   243,
     243,   243,   243,   244,   244,   244,   244,   245,   245,   245,
     245,   245,   246,   246,   247,   247,   247,   248,   248,   249,
     249,   249,   250,   250,   250,   250,   250,   251,   251,   252,
     252,   252,   252,   252,   253,   253,   254,   254,   255,   255,
     256,   256,   257,   257,   257,   258,   258,   259,   259,   260,
     260,   261,   261,   262,   262,   263,   263,   263,   264,   264,
     265,   265,   265,   265,   265,   266,   266,   267,   267,   268,
     268,   269,   269,   270,   270,   270,   271,   271,   272,   272,
     273,   273,   273,   274,   274,   275,   275,   276,   276,   277,
     277,   277,   277,   277,   277,   277,   277,   278,   278,   279,
     279,   280,   280,   281,   281,   281,   281,   281,   281,   281,
     281,   281,   281,   282,   282,   283,   283,   283,   284,   284,
     285,   285,   285,   285,   285,   285,   285,   285,   285,   286,
     286,   287,   287,   288,   288,   288,   288,   288,   288,   288,
     288,   288,   289,   289,   290,   290,   290,   291,   291,   292,
     292,   293,   293,   294,   294,   294,   295,   295,   295,   295,
     295,   295,   295,   295,   295,   295,   295,   295,   295,   296,
     296,   296,   297,   298,   298,   299,   299,   299,   300,   301,
     301,   302,   302,   302,   303,   304,   304,   305,   305,   305,
     306,   306,   307,   307,   308,   308
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     2,     1,     1,     1,     0,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     4,
       3,     2,     2,     3,     3,     0,     1,     1,     3,     3,
       3,     1,     2,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     1,     3,
       1,     3,     3,     4,     1,     3,     1,     1,     1,     0,
       1,     0,     2,     3,     1,     3,     3,     4,     1,     3,
       1,     1,     1,     1,     3,     1,     0,     2,     1,     2,
       7,     4,     5,     5,     1,     3,     2,     1,     3,     1,
       2,     3,     1,     1,     3,     1,     1,     1,     2,     1,
       1,     1,     1,     1,     3,     0,     1,     1,     3,     1,
       1,     3,     1,     2,     1,     2,     2,     2,     3,     3,
       1,     1,     1,     3,     1,     1,     1,     1,     1,     3,
       4,     0,     2,     2,     2,     4,     2,     6,     3,     4,
       4,     3,     4,     3,     4,     3,     2,     3,     3,     2,
       3,     2,     3,     2,     3,     1,     3,     3,     1,     3,
       3,     0,     2,     0,     2,     5,     6,     7,     3,     5,
       6,     7,     3,     1,     3,     3,     1,     3,     3,     3,
       4,     3,     4,     3,     2,     3,     3,     2,     3,     3,
       4,     3,     4,     3,     2,     1,     3,     1,     2,     3,
       1,     1,     3,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     3,     0,     1,     1,     3,     1,     1,     1,
       1,     3,     1,     0,     1,     0,     2,     3,     1,     3,
       3,     4,     1,     3,     1,     1,     1,     1,     1,     5,
       5,     3,     5,     5,     3,     0,     2,     6,     5,     3,
       7,     6,     3,     0,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     6,     6,     5,     4,
       3,     1,     1,     0,     4,     7,     7,     5,     4,     3,
       0,     1,     1,     3,     4,     1,     1,     1,     1,     5,
       5,     4,     3,     5,     5,     4,     3,     1,     1,     1,
       1,     1,     3,     3,     3,     2,     1,     3,     1,     2,
       3,     1,     1,     3,     1,     1,     1,     2,     1,     1,
       1,     1,     1,     3,     0,     1,     1,     3,     1,     1,
       4,     3,     0,     1,     4,     5,     3,     0,     2,     3,
       1,     3,     1,     3,     1,     1,     4,     4,     3,     3,
       3,     4,     4,     4,     3,     0,     2,     3,     1,     3,
       1,     3,     1,     1,     4,     4,     5,     3,     0,     1,
       0,     1,     4,     4,     3,     0,     1,     1,     3,     1,
       2,     1,     2,     1,     2,     1,     1,     3,     3,     0,
       1,     1,     3,     1,     2,     1,     2,     1,     2,     1,
       1,     1,     1,     3,     3,     4,     4,     3,     1,     2,
       3,     4,     6,     5,     7,     3,     4,     3,     2,     4,
       3,     1,     3,     2,     3,     1,     6,     6,     4,     8,
       3,     4,     1,     3,     4,     4,     3,     0,     2,     2,
       2,     0,     1,     1,     3,     3,     4,     6,     6,     8,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     4,
       4,     3,     3,     1,     3,     1,     2,     4,     3,     1,
       3,     1,     2,     4,     3,     1,     3,     1,     2,     4,
       2,     0,     1,     3,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 461 "rpsl.y" /* yacc.c:1648  */
    {
   YYACCEPT;
}
#line 2556 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 3:
#line 464 "rpsl.y" /* yacc.c:1648  */
    {
   YYACCEPT;
}
#line 2564 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 4:
#line 467 "rpsl.y" /* yacc.c:1648  */
    {
   handle_object_error("Error: syntax error\n");
   YYABORT;
}
#line 2573 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 5:
#line 471 "rpsl.y" /* yacc.c:1648  */
    { // end of file
   YYACCEPT;
}
#line 2581 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 6:
#line 474 "rpsl.y" /* yacc.c:1648  */
    { // end of file
   YYACCEPT;
}
#line 2589 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 7:
#line 477 "rpsl.y" /* yacc.c:1648  */
    { // end of file
   handle_object_error("Error: syntax error\n");
   YYABORT;
}
#line 2598 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 8:
#line 481 "rpsl.y" /* yacc.c:1648  */
    { // end of file
   YYABORT;
}
#line 2606 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 9:
#line 486 "rpsl.y" /* yacc.c:1648  */
    {
   (*current_object) += (yyvsp[0].attr);
}
#line 2614 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 10:
#line 489 "rpsl.y" /* yacc.c:1648  */
    {
   (*current_object) += (yyvsp[0].attr);
}
#line 2622 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 47:
#line 530 "rpsl.y" /* yacc.c:1648  */
    { // the current line started w/ non-attribute
   (yyval.attr) = changeCurrentAttr(new Attr);
   handle_error("Error: syntax error\n");
}
#line 2631 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 48:
#line 534 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = changeCurrentAttr(new Attr);
   handle_error("Error: syntax error\n");
   yyerrok;
}
#line 2641 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 49:
#line 543 "rpsl.y" /* yacc.c:1648  */
    {
   free((yyvsp[-2].string));
   (yyval.attr) = (yyvsp[-3].attr);
}
#line 2650 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 50:
#line 547 "rpsl.y" /* yacc.c:1648  */
    {
   handle_error("Error: \"changed: <email> <YYYYMMDD>\" expected\n");
   yyerrok;
}
#line 2659 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 51:
#line 553 "rpsl.y" /* yacc.c:1648  */
    {
   char *start = strchr((yyvsp[-1].attr)->object->contents + (yyvsp[-1].attr)->offset, ':') + 1;
   int len = (yyvsp[-1].attr)->object->contents + (yyvsp[-1].attr)->offset + (yyvsp[-1].attr)->len - start;
   ItemFREETEXT *ft = new ItemFREETEXT(start, len);
   ItemList *il = new ItemList;
   il->append(ft);
   
   (yyval.attr) = changeCurrentAttr(new AttrGeneric((yyvsp[-1].attr)->type, il));
}
#line 2673 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 52:
#line 564 "rpsl.y" /* yacc.c:1648  */
    {
   char *start = strchr((yyvsp[-1].attr)->object->contents + (yyvsp[-1].attr)->offset, ':') + 1;
   int len = (yyvsp[-1].attr)->object->contents + (yyvsp[-1].attr)->offset + (yyvsp[-1].attr)->len - start;

   while (isspace(*start)) {
      start++;
      len --;
   }

   char *comment = strrchr(start, '#');
   if (comment && comment < start+len)
      len = comment - start;

   while (isspace(*(start+len-1)))
      len --;

   Buffer b(len+1);
   b.append(start, len);
   b.append("", 1);

   regmatch_t *matches = (regmatch_t *) malloc(sizeof(regmatch_t) 
					       * ((yyvsp[-1].attr)->type->reIndex + 1));
   int code = regexec((yyvsp[-1].attr)->type->reComp, b.contents, 
		      (yyvsp[-1].attr)->type->reIndex + 1, matches, 0);

   if (code) {
      handle_error("Error: argument to %s should match %s.\n",
		   (yyvsp[-1].attr)->type->name(), (yyvsp[-1].attr)->type->re);
      (yyval.attr) = changeCurrentAttr(new AttrGeneric((yyvsp[-1].attr)->type, NULL));
   } else {
      Buffer *buf = new Buffer(matches[(yyvsp[-1].attr)->type->reIndex].rm_eo 
			       - matches[(yyvsp[-1].attr)->type->reIndex].rm_so);
      buf->append(b.contents + matches[(yyvsp[-1].attr)->type->reIndex].rm_so,buf->capacity);

      ItemBUFFER *item = new ItemBUFFER(buf);
      ItemList   *il = new ItemList;
      il->append(item);
   
      (yyval.attr) = changeCurrentAttr(new AttrGeneric((yyvsp[-1].attr)->type, il));
   }
}
#line 2719 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 53:
#line 607 "rpsl.y" /* yacc.c:1648  */
    {
   if (!(yyvsp[-2].attr)->type->subsyntax()->validate((yyvsp[-1].list))) {
      handle_error("Error: argument to %s should be %s.\n",
	      (yyvsp[-2].attr)->type->name(), (yyvsp[-2].attr)->type->subsyntax()->name());
      delete (yyvsp[-1].list);
      (yyval.attr) = changeCurrentAttr(new AttrGeneric((yyvsp[-2].attr)->type, NULL));
   } else 
      (yyval.attr) = changeCurrentAttr(new AttrGeneric((yyvsp[-2].attr)->type, (yyvsp[-1].list)));
}
#line 2733 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 54:
#line 616 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   handle_error("Error: argument to %s should be %s.\n",
	   (yyvsp[-2].attr)->type->name(), (yyvsp[-2].attr)->type->subsyntax()->name());
   yyerrok;
}
#line 2744 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 55:
#line 624 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.list) = new ItemList;
}
#line 2752 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 57:
#line 630 "rpsl.y" /* yacc.c:1648  */
    { 	
   (yyval.list) = new ItemList;
   (yyval.list)->append((yyvsp[0].item));
}
#line 2761 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 58:
#line 634 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.list) = (yyvsp[-2].list);
   (yyval.list)->append((yyvsp[0].item));
}
#line 2770 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 59:
#line 640 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = changeCurrentAttr(new AttrGeneric((yyvsp[-2].attr)->type, (yyvsp[-1].list)));
}
#line 2778 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 60:
#line 643 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   handle_error("Error: argument to %s should be blob sequence.\n",
	   (yyvsp[-2].attr)->type->name());
   yyerrok;
}
#line 2789 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 61:
#line 651 "rpsl.y" /* yacc.c:1648  */
    { 	
   (yyval.list) = new ItemList;
   (yyval.list)->append((yyvsp[0].item));
}
#line 2798 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 62:
#line 655 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.list) = (yyvsp[-1].list);
   (yyval.list)->append((yyvsp[0].item));
}
#line 2807 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 63:
#line 661 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = (yyvsp[0].item);
}
#line 2815 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 64:
#line 664 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemRange((yyvsp[-2].item), (yyvsp[0].item));
}
#line 2823 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 65:
#line 669 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemASNO((yyvsp[0].i));
}
#line 2831 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 66:
#line 672 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemINT((yyvsp[0].i));
}
#line 2839 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 67:
#line 675 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemREAL((yyvsp[0].real));
}
#line 2847 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 68:
#line 678 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemSTRING((yyvsp[0].string));
}
#line 2855 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 69:
#line 681 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemTimeStamp((yyvsp[0].time));
}
#line 2863 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 70:
#line 684 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemIPV4((yyvsp[0].ip));
}
#line 2871 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 71:
#line 687 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemPRFXV4((yyvsp[0].prfx));
}
#line 2879 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 72:
#line 690 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemPRFXV4Range((yyvsp[0].prfxrng));
}
#line 2887 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 73:
#line 693 "rpsl.y" /* yacc.c:1648  */
    {
  (yyval.item) = new ItemIPV6((yyvsp[0].ipv6));
}
#line 2895 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 74:
#line 696 "rpsl.y" /* yacc.c:1648  */
    {
  (yyval.item) = new ItemPRFXV6((yyvsp[0].prfxv6));
}
#line 2903 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 75:
#line 699 "rpsl.y" /* yacc.c:1648  */
    {
  (yyval.item) = new ItemPRFXV6Range((yyvsp[0].prfxv6rng));
}
#line 2911 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 76:
#line 702 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemConnection((yyvsp[-2].ip), (yyvsp[0].i));
}
#line 2919 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 77:
#line 705 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemConnection((yyvsp[-2].sid), (yyvsp[0].i));
}
#line 2927 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 78:
#line 708 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemASNAME((yyvsp[0].sid));
}
#line 2935 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 79:
#line 711 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemRSNAME((yyvsp[0].sid));
}
#line 2943 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 80:
#line 714 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemRTRSNAME((yyvsp[0].sid));
}
#line 2951 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 81:
#line 717 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemPRNGNAME((yyvsp[0].sid));
}
#line 2959 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 82:
#line 720 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemFLTRNAME((yyvsp[0].sid));
}
#line 2967 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 83:
#line 723 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemBOOLEAN((yyvsp[0].i));
}
#line 2975 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 84:
#line 726 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemWORD((yyvsp[0].string));
}
#line 2983 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 85:
#line 729 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemWORD((yyvsp[0].string));
}
#line 2991 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 86:
#line 732 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemDNS((yyvsp[0].sid));
}
#line 2999 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 87:
#line 735 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemEMAIL((yyvsp[0].string));
}
#line 3007 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 88:
#line 738 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemBLOB((yyvsp[0].string));
}
#line 3015 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 89:
#line 741 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = (yyvsp[-1].list);
}
#line 3023 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 90:
#line 744 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemFilter((yyvsp[-1].filter));
}
#line 3031 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 91:
#line 749 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = (yyvsp[0].string);
}
#line 3039 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 92:
#line 752 "rpsl.y" /* yacc.c:1648  */
    {
   char buffer[64];
   asnum_string(buffer, (yyvsp[0].i));
   (yyval.string) = strdup(buffer);
}
#line 3049 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 93:
#line 757 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup((yyvsp[0].sid));
}
#line 3057 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 94:
#line 760 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup((yyvsp[0].sid));
}
#line 3065 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 95:
#line 763 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup((yyvsp[0].sid));
}
#line 3073 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 96:
#line 766 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup((yyvsp[0].sid));
}
#line 3081 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 97:
#line 769 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup((yyvsp[0].sid));
}
#line 3089 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 98:
#line 772 "rpsl.y" /* yacc.c:1648  */
    {
   if ((yyvsp[0].i))
      (yyval.string) = strdup("true");
   else
      (yyval.string) = strdup("false");
}
#line 3100 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 100:
#line 781 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("true");
}
#line 3108 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 101:
#line 784 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("false");
}
#line 3116 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 102:
#line 787 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("action");
}
#line 3124 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 103:
#line 790 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("accept");
}
#line 3132 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 104:
#line 793 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("announce");
}
#line 3140 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 105:
#line 796 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("from");
}
#line 3148 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 106:
#line 799 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("to");
}
#line 3156 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 107:
#line 802 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("at");
}
#line 3164 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 108:
#line 805 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("any");
}
#line 3172 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 109:
#line 808 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("refine");
}
#line 3180 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 110:
#line 811 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("except");
}
#line 3188 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 111:
#line 814 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("static");
}
#line 3196 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 112:
#line 817 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("networks");
}
#line 3204 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 113:
#line 820 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("masklen");
}
#line 3212 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 114:
#line 823 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("union");
}
#line 3220 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 115:
#line 826 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("range");
}
#line 3228 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 116:
#line 829 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("list");
}
#line 3236 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 117:
#line 832 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("of");
}
#line 3244 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 118:
#line 835 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("operator");
}
#line 3252 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 119:
#line 838 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("syntax");
}
#line 3260 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 120:
#line 841 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("special");
}
#line 3268 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 121:
#line 844 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("regexp");
}
#line 3276 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 122:
#line 847 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("optional");
}
#line 3284 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 123:
#line 850 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("mandatory");
}
#line 3292 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 124:
#line 853 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("internal");
}
#line 3300 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 125:
#line 856 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("deleted");
}
#line 3308 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 126:
#line 859 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("singlevalued");
}
#line 3316 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 127:
#line 862 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("multivalued");
}
#line 3324 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 128:
#line 865 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("lookup");
}
#line 3332 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 129:
#line 868 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("key");
}
#line 3340 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 130:
#line 871 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("obsolete");
}
#line 3348 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 131:
#line 874 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("peeras");
}
#line 3356 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 132:
#line 877 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("protocol");
}
#line 3364 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 133:
#line 880 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("into");
}
#line 3372 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 134:
#line 883 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("atomic");
}
#line 3380 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 135:
#line 886 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("inbound");
}
#line 3388 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 136:
#line 889 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.string) = strdup("outbound");
}
#line 3396 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 137:
#line 898 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterASNAME(symbols.symID("AS-ANY"));
}
#line 3404 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 139:
#line 904 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterOR((yyvsp[-2].filter), (yyvsp[0].filter));
}
#line 3412 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 141:
#line 910 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterAND((yyvsp[-2].filter), (yyvsp[0].filter));
}
#line 3420 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 142:
#line 913 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterEXCEPT((yyvsp[-2].filter), (yyvsp[0].filter));
}
#line 3428 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 143:
#line 916 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterEXCEPT((yyvsp[-3].filter), (yyvsp[0].filter));
}
#line 3436 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 145:
#line 922 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = (yyvsp[-1].filter);
}
#line 3444 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 147:
#line 928 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterASNO((yyvsp[0].i));
}
#line 3452 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 148:
#line 931 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterASNAME((yyvsp[0].sid));
}
#line 3460 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 149:
#line 938 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterANY;
}
#line 3468 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 150:
#line 941 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = (yyvsp[0].filter);
}
#line 3476 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 151:
#line 946 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterANY;
}
#line 3484 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 152:
#line 949 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = (yyvsp[0].filter);
}
#line 3492 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 153:
#line 954 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterOR((yyvsp[-2].filter), (yyvsp[0].filter));
}
#line 3500 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 155:
#line 960 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterAND((yyvsp[-2].filter), (yyvsp[0].filter));
}
#line 3508 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 156:
#line 963 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterEXCEPT((yyvsp[-2].filter), (yyvsp[0].filter));
}
#line 3516 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 157:
#line 966 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterEXCEPT((yyvsp[-3].filter), (yyvsp[0].filter));
}
#line 3524 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 159:
#line 973 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = (yyvsp[-1].filter);
}
#line 3532 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 161:
#line 979 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterRouter((yyvsp[0].ip));
}
#line 3540 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 162:
#line 982 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterRouterName((yyvsp[0].sid));
}
#line 3548 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 163:
#line 985 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterRTRSNAME((yyvsp[0].sid));
}
#line 3556 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 164:
#line 992 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.peering) = new PolicyPeering((yyvsp[-2].filter), (yyvsp[-1].filter), (yyvsp[0].filter));
}
#line 3564 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 165:
#line 995 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.peering) = new PolicyPeering((yyvsp[0].sid));
}
#line 3572 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 166:
#line 1002 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.actionList) = new PolicyActionList;
}
#line 3580 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 167:
#line 1005 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.actionList) = (yyvsp[0].actionList);
}
#line 3588 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 168:
#line 1010 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.actionList) = new PolicyActionList;
   if ((yyvsp[0].actionNode))
      (yyval.actionList)->append((yyvsp[0].actionNode));  
}
#line 3598 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 169:
#line 1015 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.actionList) = (yyvsp[-1].actionList);
   if ((yyvsp[0].actionNode))
      (yyval.actionList)->append((yyvsp[0].actionNode));  
}
#line 3608 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 170:
#line 1022 "rpsl.y" /* yacc.c:1648  */
    {
   const AttrMethod *mtd = searchMethod((yyvsp[-6].rp_attr), (yyvsp[-4].string), (yyvsp[-2].list));
   if (mtd)
      (yyval.actionNode) = new PolicyAction((yyvsp[-6].rp_attr), mtd, (yyvsp[-2].list));
   else {
      delete (yyvsp[-2].list);
      (yyval.actionNode) = NULL;
   }
   free((yyvsp[-4].string));
}
#line 3623 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 171:
#line 1032 "rpsl.y" /* yacc.c:1648  */
    {
   ItemList *plist = new ItemList;
   plist->append((yyvsp[-1].item));

   const AttrMethod *mtd = searchMethod((yyvsp[-3].rp_attr), (yyvsp[-2].string), plist);
   if (mtd)
      (yyval.actionNode) = new PolicyAction((yyvsp[-3].rp_attr), mtd, plist);
   else {
      delete plist;
      (yyval.actionNode) = NULL;
   }
   free((yyvsp[-2].string));
}
#line 3641 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 172:
#line 1045 "rpsl.y" /* yacc.c:1648  */
    {
   const AttrMethod *mtd = searchMethod((yyvsp[-4].rp_attr), "()", (yyvsp[-2].list));
   if (mtd)
      (yyval.actionNode) = new PolicyAction((yyvsp[-4].rp_attr), mtd, (yyvsp[-2].list));
   else {
      delete (yyvsp[-2].list);
      (yyval.actionNode) = NULL;
   }
}
#line 3655 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 173:
#line 1054 "rpsl.y" /* yacc.c:1648  */
    {
   const AttrMethod *mtd = searchMethod((yyvsp[-4].rp_attr), "[]", (yyvsp[-2].list));
   if (mtd)
      (yyval.actionNode) = new PolicyAction((yyvsp[-4].rp_attr), mtd, (yyvsp[-2].list));
   else {
      delete (yyvsp[-2].list);
      (yyval.actionNode) = NULL;
   }
}
#line 3669 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 174:
#line 1063 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.actionNode) = NULL;
}
#line 3677 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 175:
#line 1071 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterOR((yyvsp[-2].filter), (yyvsp[0].filter));
}
#line 3685 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 176:
#line 1074 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterOR((yyvsp[-1].filter), (yyvsp[0].filter));
}
#line 3693 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 178:
#line 1080 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterAND((yyvsp[-2].filter), (yyvsp[0].filter));
}
#line 3701 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 180:
#line 1086 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterNOT((yyvsp[0].filter));
}
#line 3709 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 181:
#line 1089 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = (yyvsp[-1].filter);
}
#line 3717 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 183:
#line 1095 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterANY;
}
#line 3725 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 184:
#line 1098 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterASPath((yyvsp[-1].re));
}
#line 3733 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 185:
#line 1101 "rpsl.y" /* yacc.c:1648  */
    {
   if ((yyvsp[0].filter))
      (yyval.filter) = (yyvsp[0].filter);
   else
      (yyval.filter) = new FilterNOT(new FilterANY);
}
#line 3744 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 186:
#line 1107 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterFLTRNAME((yyvsp[0].sid));
}
#line 3752 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 188:
#line 1113 "rpsl.y" /* yacc.c:1648  */
    {
   (yyvsp[0].moreSpecOp)->f1 = (yyvsp[-1].filter);
   (yyval.filter) = (yyvsp[0].moreSpecOp);
}
#line 3761 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 190:
#line 1120 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterASNO((yyvsp[0].i));
}
#line 3769 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 191:
#line 1123 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterPeerAS;
}
#line 3777 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 192:
#line 1126 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterASNAME((yyvsp[0].sid));
}
#line 3785 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 193:
#line 1129 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterRSNAME((yyvsp[0].sid));
}
#line 3793 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 194:
#line 1132 "rpsl.y" /* yacc.c:1648  */
    { 
   (yyval.filter) = (yyvsp[-1].filter); 
}
#line 3801 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 195:
#line 1137 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterPRFXList;
}
#line 3809 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 196:
#line 1140 "rpsl.y" /* yacc.c:1648  */
    {
  (yyval.filter) = (yyvsp[0].filter);
}
#line 3817 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 197:
#line 1145 "rpsl.y" /* yacc.c:1648  */
    {
   ((FilterPRFXList *) ((yyval.filter) = new FilterPRFXList))->add_high(*(yyvsp[0].prfxrng));
   delete (yyvsp[0].prfxrng);
}
#line 3826 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 198:
#line 1149 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = (yyvsp[-2].filter);
   ((FilterPRFXList *) ((yyval.filter)))->add_high(*(yyvsp[0].prfxrng));
   delete (yyvsp[0].prfxrng);
}
#line 3836 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 199:
#line 1156 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.prfxrng) = (yyvsp[0].prfx);
}
#line 3844 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 200:
#line 1159 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.prfxrng) = (yyvsp[0].prfxrng);
}
#line 3852 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 201:
#line 1164 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.re) = new regexp_or((yyvsp[-2].re), (yyvsp[0].re));
}
#line 3860 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 203:
#line 1170 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.re) = new regexp_cat((yyvsp[-1].re), (yyvsp[0].re));
}
#line 3868 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 205:
#line 1176 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.re) = new regexp_star((yyvsp[-1].re));
}
#line 3876 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 206:
#line 1179 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.re) = new regexp_question((yyvsp[-1].re));
}
#line 3884 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 207:
#line 1182 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.re) = new regexp_plus((yyvsp[-1].re));
}
#line 3892 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 208:
#line 1185 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.re) = new regexp_tildaplus((yyvsp[-2].re));
}
#line 3900 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 209:
#line 1188 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.re) = new regexp_tildastar((yyvsp[-2].re));
}
#line 3908 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 211:
#line 1194 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.re) = new regexp_bol;
}
#line 3916 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 212:
#line 1197 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.re) = new regexp_eol;
}
#line 3924 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 213:
#line 1200 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.re) = (yyvsp[-1].re);
}
#line 3932 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 215:
#line 1206 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.re) = new regexp_symbol((yyvsp[0].i));
}
#line 3940 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 216:
#line 1209 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.re) = new regexp_symbol(symbols.symID("PEERAS"));
}
#line 3948 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 217:
#line 1212 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.re) = new regexp_symbol((yyvsp[0].sid));
}
#line 3956 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 218:
#line 1215 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.re) = new regexp_symbol(regexp_symbol::MIN_AS, regexp_symbol::MAX_AS);
}
#line 3964 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 219:
#line 1218 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.re) = (yyvsp[-1].re);
}
#line 3972 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 220:
#line 1221 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.re) = (yyvsp[-1].re);
   ((regexp_symbol *) (yyval.re))->complement();
}
#line 3981 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 221:
#line 1227 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.re) = new regexp_symbol;
}
#line 3989 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 222:
#line 1230 "rpsl.y" /* yacc.c:1648  */
    {
   ((regexp_symbol *) ((yyval.re) = (yyvsp[-1].re)))->add((yyvsp[0].i));
}
#line 3997 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 223:
#line 1233 "rpsl.y" /* yacc.c:1648  */
    {
   ((regexp_symbol *) ((yyval.re) = (yyvsp[-1].re)))->add(symbols.symID("PEERAS"));
}
#line 4005 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 224:
#line 1236 "rpsl.y" /* yacc.c:1648  */
    {
   ((regexp_symbol *) ((yyval.re) = (yyvsp[-1].re)))->add(regexp_symbol::MIN_AS, regexp_symbol::MAX_AS);
}
#line 4013 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 225:
#line 1239 "rpsl.y" /* yacc.c:1648  */
    {
   ((regexp_symbol *) ((yyval.re) = (yyvsp[-3].re)))->add((yyvsp[-2].i), (yyvsp[0].i));
}
#line 4021 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 226:
#line 1242 "rpsl.y" /* yacc.c:1648  */
    {
   ((regexp_symbol *) ((yyval.re) = (yyvsp[-1].re)))->add((yyvsp[0].sid));
}
#line 4029 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 227:
#line 1247 "rpsl.y" /* yacc.c:1648  */
    {
   const AttrMethod *mtd = searchMethod((yyvsp[-5].rp_attr), (yyvsp[-3].string), (yyvsp[-1].list));
   if (mtd)
      (yyval.filter) = new FilterRPAttribute((yyvsp[-5].rp_attr), mtd, (yyvsp[-1].list));
   else {
      delete (yyvsp[-1].list);
      (yyval.filter) = NULL;
   }
   free((yyvsp[-3].string));
}
#line 4044 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 228:
#line 1257 "rpsl.y" /* yacc.c:1648  */
    {
   ItemList *plist = new ItemList;
   plist->append((yyvsp[0].item));

   const AttrMethod *mtd = searchMethod((yyvsp[-2].rp_attr), (yyvsp[-1].string), plist);
   if (mtd)
      (yyval.filter) = new FilterRPAttribute((yyvsp[-2].rp_attr), mtd, plist);
   else {
      delete plist;
      (yyval.filter) = NULL;
   }
   free((yyvsp[-1].string));
}
#line 4062 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 229:
#line 1270 "rpsl.y" /* yacc.c:1648  */
    {
   const AttrMethod *mtd = searchMethod((yyvsp[-3].rp_attr), "()", (yyvsp[-1].list));
   if (mtd)
      (yyval.filter) = new FilterRPAttribute((yyvsp[-3].rp_attr), mtd, (yyvsp[-1].list));
   else {
      delete (yyvsp[-1].list);
      (yyval.filter) = NULL;
   }
}
#line 4076 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 230:
#line 1279 "rpsl.y" /* yacc.c:1648  */
    {
   const AttrMethod *mtd = searchMethod((yyvsp[-3].rp_attr), "[]", (yyvsp[-1].list));
   if (mtd)
      (yyval.filter) = new FilterRPAttribute((yyvsp[-3].rp_attr), mtd, (yyvsp[-1].list));
   else {
      delete (yyvsp[-1].list);
      (yyval.filter) = NULL;
   }
}
#line 4090 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 231:
#line 1292 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.peeringActionList) = new List<PolicyPeeringAction>;
   (yyval.peeringActionList)->append(new PolicyPeeringAction((yyvsp[-1].peering), (yyvsp[0].actionList)));
}
#line 4099 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 232:
#line 1296 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.peeringActionList) = (yyvsp[-3].peeringActionList);
   (yyval.peeringActionList)->append(new PolicyPeeringAction((yyvsp[-1].peering), (yyvsp[0].actionList)));
}
#line 4108 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 233:
#line 1302 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.peeringActionList) = new List<PolicyPeeringAction>;
   (yyval.peeringActionList)->append(new PolicyPeeringAction((yyvsp[-1].peering), (yyvsp[0].actionList)));
}
#line 4117 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 234:
#line 1306 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.peeringActionList) = (yyvsp[-3].peeringActionList);
   (yyval.peeringActionList)->append(new PolicyPeeringAction((yyvsp[-1].peering), (yyvsp[0].actionList)));
}
#line 4126 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 235:
#line 1314 "rpsl.y" /* yacc.c:1648  */
    {
   ItemList *afi_list = new ItemList;
   afi_list->append(new ItemAFI("ipv4.unicast"));
   (yyval.policyFactor) = new PolicyFactor((yyvsp[-2].peeringActionList), new FilterAFI (afi_list, (yyvsp[0].filter)));
}
#line 4136 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 236:
#line 1321 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.policyTerm) = new PolicyTerm;
   (yyval.policyTerm)->append((yyvsp[-1].policyFactor));
}
#line 4145 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 237:
#line 1325 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.policyTerm) = (yyvsp[-2].policyTerm);
   (yyval.policyTerm)->append((yyvsp[-1].policyFactor));
}
#line 4154 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 238:
#line 1331 "rpsl.y" /* yacc.c:1648  */
    {
   ItemList *afi_list = new ItemList;
   afi_list->append(new ItemAFI("ipv4.unicast"));
   (yyval.policyFactor) = new PolicyFactor((yyvsp[-2].peeringActionList), new FilterAFI (afi_list, (yyvsp[0].filter)));
}
#line 4164 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 239:
#line 1338 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.policyTerm) = new PolicyTerm;
   (yyval.policyTerm)->append((yyvsp[-1].policyFactor));
}
#line 4173 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 240:
#line 1342 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.policyTerm) = (yyvsp[-2].policyTerm);
   (yyval.policyTerm)->append((yyvsp[-1].policyFactor));
}
#line 4182 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 241:
#line 1350 "rpsl.y" /* yacc.c:1648  */
    {
   PolicyTerm *term = new PolicyTerm;
   term->append((yyvsp[-1].policyFactor));
   (yyval.policyTerm) = term;
}
#line 4192 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 242:
#line 1355 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.policyTerm) = (yyvsp[-1].policyTerm);
}
#line 4200 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 243:
#line 1360 "rpsl.y" /* yacc.c:1648  */
    {
   PolicyTerm *term = new PolicyTerm;
   term->append((yyvsp[-1].policyFactor));
   (yyval.policyTerm) = term;
}
#line 4210 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 244:
#line 1365 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.policyTerm) = (yyvsp[-1].policyTerm);
}
#line 4218 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 245:
#line 1372 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.policyExpr) = (yyvsp[0].policyTerm);
}
#line 4226 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 246:
#line 1375 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.policyExpr) = new PolicyRefine((yyvsp[-2].policyTerm), (yyvsp[0].policyExpr));
}
#line 4234 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 247:
#line 1378 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.policyExpr) = new PolicyExcept((yyvsp[-2].policyTerm), (yyvsp[0].policyExpr));
}
#line 4242 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 248:
#line 1383 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.policyExpr) = (yyvsp[0].policyTerm);
}
#line 4250 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 249:
#line 1386 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.policyExpr) = new PolicyRefine((yyvsp[-2].policyTerm), (yyvsp[0].policyExpr));
}
#line 4258 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 250:
#line 1389 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.policyExpr) = new PolicyExcept((yyvsp[-2].policyTerm), (yyvsp[0].policyExpr));
}
#line 4266 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 251:
#line 1396 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.protocol) = schema.searchProtocol("BGP4");
}
#line 4274 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 252:
#line 1399 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.protocol) = schema.searchProtocol((yyvsp[0].string));
   if (!(yyval.protocol)) {
      handle_warning("Warning: unknown protocol %s, BGP4 assumed.\n", (yyvsp[0].string));
      (yyval.protocol) = schema.searchProtocol("BGP4");
   }
   free((yyvsp[0].string));
}
#line 4287 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 253:
#line 1409 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.protocol) = schema.searchProtocol("BGP4");
}
#line 4295 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 254:
#line 1412 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.protocol) = schema.searchProtocol((yyvsp[0].string));
   if (!(yyval.protocol)) {
      handle_warning("Warning: unknown protocol %s, BGP4 assumed.\n", (yyvsp[0].string));
      (yyval.protocol) = schema.searchProtocol("BGP4");
   }
   free((yyvsp[0].string));;
}
#line 4308 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 255:
#line 1425 "rpsl.y" /* yacc.c:1648  */
    {
  (yyval.attr) = changeCurrentAttr(new AttrImport((yyvsp[-3].protocol), (yyvsp[-2].protocol), (yyvsp[-1].policyExpr)));
}
#line 4316 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 256:
#line 1428 "rpsl.y" /* yacc.c:1648  */
    {
   PolicyTerm *term = new PolicyTerm;
   (yyvsp[-1].policyFactor)->filter = new FilterAFI((yyvsp[-2].list), (yyvsp[-1].policyFactor)->filter);
   term->append((yyvsp[-1].policyFactor));
   (yyval.attr) = changeCurrentAttr(new AttrImport((yyvsp[-4].protocol), (yyvsp[-3].protocol), term));
}
#line 4327 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 257:
#line 1434 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-6].attr);
   handle_error ("Error: in peering/filter specification\n");
   yyerrok;
}
#line 4337 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 258:
#line 1439 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   handle_error("Error: wrong mp-import.\n");
   yyerrok;
}
#line 4347 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 259:
#line 1448 "rpsl.y" /* yacc.c:1648  */
    {
  (yyval.attr) = changeCurrentAttr(new AttrExport((yyvsp[-3].protocol), (yyvsp[-2].protocol), (yyvsp[-1].policyExpr)));
}
#line 4355 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 260:
#line 1451 "rpsl.y" /* yacc.c:1648  */
    {
   PolicyTerm *term = new PolicyTerm;
   (yyvsp[-1].policyFactor)->filter = new FilterAFI((yyvsp[-2].list), (yyvsp[-1].policyFactor)->filter);
   term->append((yyvsp[-1].policyFactor));
   (yyval.attr) = changeCurrentAttr(new AttrExport((yyvsp[-4].protocol), (yyvsp[-3].protocol), term));
}
#line 4366 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 261:
#line 1457 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-6].attr);
   handle_error ("Error: in peering/filter specification\n");
   yyerrok;
}
#line 4376 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 262:
#line 1462 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   handle_error("Error: wrong mp-export.\n");
   yyerrok;
}
#line 4386 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 263:
#line 1470 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.policyExpr) = (yyvsp[0].policyTerm);
}
#line 4394 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 264:
#line 1473 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.policyExpr) = new PolicyRefine((yyvsp[-2].policyTerm), (yyvsp[0].policyExpr));
}
#line 4402 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 265:
#line 1476 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.policyExpr) = new PolicyExcept((yyvsp[-2].policyTerm), (yyvsp[0].policyExpr));
}
#line 4410 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 266:
#line 1481 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.policyExpr) = (yyvsp[0].policyTerm);
}
#line 4418 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 267:
#line 1484 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.policyExpr) = new PolicyRefine((yyvsp[-2].policyTerm), (yyvsp[0].policyExpr));
}
#line 4426 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 268:
#line 1487 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.policyExpr) = new PolicyExcept((yyvsp[-2].policyTerm), (yyvsp[0].policyExpr));
}
#line 4434 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 269:
#line 1494 "rpsl.y" /* yacc.c:1648  */
    {
   PolicyTerm *term = new PolicyTerm;
   (yyvsp[-1].policyFactor)->filter = new FilterAFI((yyvsp[-2].list), (yyvsp[-1].policyFactor)->filter);
   term->append((yyvsp[-1].policyFactor));
   (yyval.policyTerm) = term;
}
#line 4445 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 270:
#line 1500 "rpsl.y" /* yacc.c:1648  */
    {
   for (PolicyFactor *pf = (yyvsp[-1].policyTerm)->head(); pf; pf = (yyvsp[-1].policyTerm)->next(pf)) {
     pf->filter = new FilterAFI((yyvsp[-3].list), pf->filter);
   }
   (yyval.policyTerm) = (yyvsp[-1].policyTerm);
}
#line 4456 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 271:
#line 1508 "rpsl.y" /* yacc.c:1648  */
    {
   PolicyTerm *term = new PolicyTerm;
   (yyvsp[-1].policyFactor)->filter = new FilterAFI((yyvsp[-2].list), (yyvsp[-1].policyFactor)->filter);
   term->append((yyvsp[-1].policyFactor));
   (yyval.policyTerm) = term;
}
#line 4467 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 272:
#line 1514 "rpsl.y" /* yacc.c:1648  */
    {
   for (PolicyFactor *pf = (yyvsp[-1].policyTerm)->head(); pf; pf = (yyvsp[-1].policyTerm)->next(pf)) {
     pf->filter = new FilterAFI((yyvsp[-3].list), pf->filter);
   }
   (yyval.policyTerm) = (yyvsp[-1].policyTerm);
}
#line 4478 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 273:
#line 1524 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.policyFactor) = new PolicyFactor((yyvsp[-2].peeringActionList), (yyvsp[0].filter));
}
#line 4486 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 274:
#line 1529 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.policyTerm) = new PolicyTerm;
   (yyval.policyTerm)->append((yyvsp[-1].policyFactor));
}
#line 4495 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 275:
#line 1533 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.policyTerm) = (yyvsp[-2].policyTerm);
   (yyval.policyTerm)->append((yyvsp[-1].policyFactor));
}
#line 4504 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 276:
#line 1539 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.policyFactor) = new PolicyFactor((yyvsp[-2].peeringActionList), (yyvsp[0].filter));
}
#line 4512 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 277:
#line 1544 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.policyTerm) = new PolicyTerm;
   (yyval.policyTerm)->append((yyvsp[-1].policyFactor));
}
#line 4521 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 278:
#line 1548 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.policyTerm) = (yyvsp[-2].policyTerm);
   (yyval.policyTerm)->append((yyvsp[-1].policyFactor));
}
#line 4530 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 279:
#line 1556 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.peeringActionList) = new List<PolicyPeeringAction>;
   (yyval.peeringActionList)->append(new PolicyPeeringAction((yyvsp[-1].peering), (yyvsp[0].actionList)));
}
#line 4539 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 280:
#line 1560 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.peeringActionList) = (yyvsp[-3].peeringActionList);
   (yyval.peeringActionList)->append(new PolicyPeeringAction((yyvsp[-1].peering), (yyvsp[0].actionList)));
}
#line 4548 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 281:
#line 1566 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.peeringActionList) = new List<PolicyPeeringAction>;
   (yyval.peeringActionList)->append(new PolicyPeeringAction((yyvsp[-1].peering), (yyvsp[0].actionList)));
}
#line 4557 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 282:
#line 1570 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.peeringActionList) = (yyvsp[-3].peeringActionList);
   (yyval.peeringActionList)->append(new PolicyPeeringAction((yyvsp[-1].peering), (yyvsp[0].actionList)));
}
#line 4566 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 283:
#line 1578 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterOR((yyvsp[-2].filter), (yyvsp[0].filter));
}
#line 4574 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 284:
#line 1581 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterOR((yyvsp[-1].filter), (yyvsp[0].filter));
}
#line 4582 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 286:
#line 1587 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterAND((yyvsp[-2].filter), (yyvsp[0].filter));
}
#line 4590 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 288:
#line 1593 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterNOT((yyvsp[0].filter));
}
#line 4598 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 289:
#line 1596 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = (yyvsp[-1].filter);
}
#line 4606 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 291:
#line 1602 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterANY;
}
#line 4614 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 292:
#line 1605 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterASPath((yyvsp[-1].re));
}
#line 4622 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 293:
#line 1608 "rpsl.y" /* yacc.c:1648  */
    {
   if ((yyvsp[0].filter))
      (yyval.filter) = (yyvsp[0].filter);
   else
      (yyval.filter) = new FilterNOT(new FilterANY);
}
#line 4633 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 294:
#line 1614 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterFLTRNAME((yyvsp[0].sid));
}
#line 4641 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 296:
#line 1620 "rpsl.y" /* yacc.c:1648  */
    {
   (yyvsp[0].moreSpecOp)->f1 = (yyvsp[-1].filter);
   (yyval.filter) = (yyvsp[0].moreSpecOp);
}
#line 4650 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 298:
#line 1627 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterASNO((yyvsp[0].i));
}
#line 4658 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 299:
#line 1630 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterPeerAS;
}
#line 4666 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 300:
#line 1633 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterASNAME((yyvsp[0].sid));
}
#line 4674 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 301:
#line 1636 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterRSNAME((yyvsp[0].sid));
}
#line 4682 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 302:
#line 1639 "rpsl.y" /* yacc.c:1648  */
    { 
   (yyval.filter) = (yyvsp[-1].filter); 
}
#line 4690 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 303:
#line 1644 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterMPPRFXList;
}
#line 4698 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 305:
#line 1650 "rpsl.y" /* yacc.c:1648  */
    {

   ((FilterMPPRFXList *) ((yyval.filter) = new FilterMPPRFXList))->push_back(*(yyvsp[0].mpprefix));
}
#line 4707 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 306:
#line 1654 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = (yyvsp[-2].filter);
   ((FilterMPPRFXList *) ((yyval.filter)))->push_back(*(yyvsp[0].mpprefix));
}
#line 4716 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 307:
#line 1660 "rpsl.y" /* yacc.c:1648  */
    {
  (yyval.mpprefix) = new MPPrefix((yyvsp[0].prfxv6));
}
#line 4724 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 308:
#line 1663 "rpsl.y" /* yacc.c:1648  */
    {
  (yyval.mpprefix) = new MPPrefix((yyvsp[0].prfxv6rng));
}
#line 4732 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 309:
#line 1666 "rpsl.y" /* yacc.c:1648  */
    {
  (yyval.mpprefix) = new MPPrefix((yyvsp[0].prfx));
}
#line 4740 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 310:
#line 1669 "rpsl.y" /* yacc.c:1648  */
    {
  (yyval.mpprefix) = new MPPrefix((yyvsp[0].prfxrng));
}
#line 4748 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 311:
#line 1676 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.peering) = new PolicyPeering((yyvsp[-2].filter), (yyvsp[-1].filter), (yyvsp[0].filter));
// need to check here that afi in opt_mp_router_expr == afi in opt_mp_router_expr_with_at ?

}
#line 4758 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 312:
#line 1681 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.peering) = new PolicyPeering((yyvsp[0].sid));
}
#line 4766 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 313:
#line 1688 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterANY;
}
#line 4774 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 314:
#line 1691 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = (yyvsp[0].filter);
}
#line 4782 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 315:
#line 1696 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterANY;
}
#line 4790 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 316:
#line 1699 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = (yyvsp[0].filter);
}
#line 4798 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 317:
#line 1704 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterOR((yyvsp[-2].filter), (yyvsp[0].filter));
}
#line 4806 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 319:
#line 1710 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterAND((yyvsp[-2].filter), (yyvsp[0].filter));
}
#line 4814 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 320:
#line 1713 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterEXCEPT((yyvsp[-2].filter), (yyvsp[0].filter));
}
#line 4822 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 321:
#line 1716 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterEXCEPT((yyvsp[-3].filter), (yyvsp[0].filter));
}
#line 4830 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 323:
#line 1722 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = (yyvsp[-1].filter);
}
#line 4838 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 325:
#line 1728 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterRouter((yyvsp[0].ip));
}
#line 4846 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 326:
#line 1731 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterRouter((yyvsp[0].ipv6));
}
#line 4854 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 327:
#line 1734 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterRouterName((yyvsp[0].sid));
}
#line 4862 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 328:
#line 1737 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterRTRSNAME((yyvsp[0].sid));
}
#line 4870 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 329:
#line 1746 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = changeCurrentAttr(new AttrImport((yyvsp[-3].protocol), (yyvsp[-2].protocol), (yyvsp[-1].policyExpr)));
}
#line 4878 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 330:
#line 1749 "rpsl.y" /* yacc.c:1648  */
    {
   PolicyTerm *term = new PolicyTerm;
   term->append((yyvsp[-1].policyFactor));

   (yyval.attr) = changeCurrentAttr(new AttrImport((yyvsp[-3].protocol), (yyvsp[-2].protocol), term));
}
#line 4889 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 331:
#line 1755 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   handle_error("Error: from <peering> expected.\n");
   yyerrok;
}
#line 4899 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 332:
#line 1764 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = changeCurrentAttr(new AttrExport((yyvsp[-3].protocol), (yyvsp[-2].protocol), (yyvsp[-1].policyExpr)));
}
#line 4907 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 333:
#line 1767 "rpsl.y" /* yacc.c:1648  */
    {
   PolicyTerm *term = new PolicyTerm;
   term->append((yyvsp[-1].policyFactor));

   (yyval.attr) = changeCurrentAttr(new AttrExport((yyvsp[-3].protocol), (yyvsp[-2].protocol), term));
}
#line 4918 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 334:
#line 1773 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   handle_error("Error: to <peering> expected.\n");
   yyerrok;
}
#line 4928 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 335:
#line 1780 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterANY;
}
#line 4936 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 336:
#line 1783 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = (yyvsp[0].filter);
}
#line 4944 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 337:
#line 1792 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = changeCurrentAttr(new AttrDefault((yyvsp[-3].peering), (yyvsp[-2].actionList), (yyvsp[-1].filter)));
}
#line 4952 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 338:
#line 1795 "rpsl.y" /* yacc.c:1648  */
    {
   if ((yyvsp[-2].peering))
      delete (yyvsp[-2].peering);
   handle_error("Error: badly formed filter/action or keyword NETWORKS/ACTION missing.\n");
   yyerrok;
}
#line 4963 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 339:
#line 1801 "rpsl.y" /* yacc.c:1648  */
    {
   handle_error("Error: TO <peer> missing.\n");
   yyerrok;
}
#line 4972 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 340:
#line 1812 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = changeCurrentAttr(new AttrDefault((yyvsp[-5].list), (yyvsp[-3].peering), (yyvsp[-2].actionList), (yyvsp[-1].filter)));
}
#line 4980 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 341:
#line 1815 "rpsl.y" /* yacc.c:1648  */
    {
   if ((yyvsp[-2].peering))
      delete (yyvsp[-2].peering);
   handle_error("Error: badly formed filter/action or keyword NETWORKS/ACTION missing.\n");
   yyerrok;
}
#line 4991 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 342:
#line 1821 "rpsl.y" /* yacc.c:1648  */
    {
   handle_error("Error: TO <peer> missing. in mp-default\n");
   yyerrok;
}
#line 5000 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 343:
#line 1827 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterANY;
}
#line 5008 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 344:
#line 1830 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = (yyvsp[0].filter);
}
#line 5016 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 345:
#line 1837 "rpsl.y" /* yacc.c:1648  */
    {
  // check that "mp-filter:" is not present
   if (current_object->hasAttr("mp-filter")) {
     handle_error("Error: mp-filter and filter attributes can't be used together\n");
     yyerrok;
    } else {
      //$$ = changeCurrentAttr(new AttrFilter($2));
      (yyval.attr) = changeCurrentAttr(new AttrFilter(new FilterAFI(new ItemAFI(new AddressFamily("ipv4.unicast")), (yyvsp[-1].filter))));
    }
}
#line 5031 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 346:
#line 1847 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   handle_error("Error: badly formed filter.\n");
   yyerrok;
}
#line 5041 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 347:
#line 1856 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = changeCurrentAttr(new AttrMPPeval((yyvsp[-1].filter)));
}
#line 5049 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 348:
#line 1859 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   handle_error("Error: badly formed filter in mp-peval.\n");
   yyerrok;
}
#line 5059 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 349:
#line 1866 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterAFI((ItemList *) (yyvsp[-1].list), (yyvsp[0].filter));
}
#line 5067 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 350:
#line 1873 "rpsl.y" /* yacc.c:1648  */
    {
  // check that "filter:" is not present
   if (current_object->hasAttr("filter")) {
    handle_error("Error: mp-filter and filter attributes can't be used together\n");
    yyerrok;
  } else {
    (yyval.attr) = changeCurrentAttr(new AttrFilter((yyvsp[-1].filter)));
  }
}
#line 5081 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 351:
#line 1882 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   handle_error("Error: badly formed filter in mp-filter.\n");
   yyerrok;
}
#line 5091 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 352:
#line 1891 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = changeCurrentAttr(new AttrPeering((yyvsp[-1].peering)));
}
#line 5099 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 353:
#line 1894 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   handle_error("Error: badly formed filter.\n");
   yyerrok;
}
#line 5109 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 354:
#line 1903 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = changeCurrentAttr(new AttrPeering((yyvsp[-1].peering)));
}
#line 5117 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 355:
#line 1906 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   handle_error("Error: badly formed peering.\n");
   yyerrok;
}
#line 5127 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 356:
#line 1917 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = changeCurrentAttr(new AttrIfAddr(new MPPrefix((PrefixRange *) (yyvsp[-4].ip)), (yyvsp[-2].i), (yyvsp[-1].actionList), NULL));
}
#line 5135 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 357:
#line 1920 "rpsl.y" /* yacc.c:1648  */
    {
   delete (yyvsp[-4].ip);
   (yyval.attr) = (yyvsp[-5].attr);
   handle_error("Error: in action specification.\n");
   yyerrok;
}
#line 5146 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 358:
#line 1926 "rpsl.y" /* yacc.c:1648  */
    {
   delete (yyvsp[-3].ip);
   (yyval.attr) = (yyvsp[-4].attr);
   handle_error("Error: integer mask length expected.\n");
   yyerrok;
}
#line 5157 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 359:
#line 1932 "rpsl.y" /* yacc.c:1648  */
    {
   delete (yyvsp[-2].ip);
   (yyval.attr) = (yyvsp[-3].attr);
   handle_error("Error: MASKLEN <length> expected.\n");
   yyerrok;
}
#line 5168 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 360:
#line 1938 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   handle_error("Error: <ip_address> MASKLEN <length> [<action>] expected.\n");
   yyerrok;
}
#line 5178 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 361:
#line 1947 "rpsl.y" /* yacc.c:1648  */
    {
  (yyval.mpprefix) = new MPPrefix((yyvsp[0].ip));
}
#line 5186 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 362:
#line 1950 "rpsl.y" /* yacc.c:1648  */
    {
  (yyval.mpprefix) = new MPPrefix((yyvsp[0].ipv6));
}
#line 5194 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 363:
#line 1955 "rpsl.y" /* yacc.c:1648  */
    {
  (yyval.tunnel) = NULL;
}
#line 5202 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 364:
#line 1958 "rpsl.y" /* yacc.c:1648  */
    {
  (yyval.tunnel) = new Tunnel((yyvsp[-2].mpprefix), new ItemWORD((yyvsp[0].string)));
  if (! (schema.searchTypedef("encapsulation"))->validate(new ItemWORD((yyvsp[0].string)))) {
     delete (yyval.tunnel);
     handle_error("Error: wrong encapsulation specified.\n");
     yyerrok;
  }
}
#line 5215 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 365:
#line 1970 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = changeCurrentAttr(new AttrIfAddr((yyvsp[-5].mpprefix), (yyvsp[-3].i), (yyvsp[-2].actionList), (yyvsp[-1].tunnel)));
   if ((yyvsp[-1].tunnel)) {
      if (((yyvsp[-5].mpprefix)->ipv4 && (yyvsp[-1].tunnel)->remote_ip->ipv6) || ((yyvsp[-5].mpprefix)->ipv6 && (yyvsp[-1].tunnel)->remote_ip->ipv4)) {
        handle_error("Error: address family mismatch in local/remote tunnel endpoint\n");
        yyerrok;
      }
   }
}
#line 5229 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 366:
#line 1979 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-6].attr);
   handle_error("Error: error in tunnel specification.\n");
   yyerrok;
}
#line 5239 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 367:
#line 1984 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-4].attr);
   handle_error("Error: integer mask length expected.\n");
   yyerrok;
}
#line 5249 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 368:
#line 1989 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-3].attr);
   handle_error("Error: MASKLEN <length> expected.\n");
   yyerrok;
}
#line 5259 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 369:
#line 1994 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   handle_error("Error: <ip_address> MASKLEN <length> [<action>] [<tunnel>] expected.\n");
   yyerrok;
}
#line 5269 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 370:
#line 2003 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.peer_option_list) = new List<AttrPeerOption>;
}
#line 5277 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 371:
#line 2006 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.peer_option_list) = (yyvsp[0].peer_option_list);
}
#line 5285 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 372:
#line 2011 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.peer_option_list) = new List<AttrPeerOption>;
   (yyval.peer_option_list)->append((yyvsp[0].peer_option));
}
#line 5294 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 373:
#line 2015 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.peer_option_list) = (yyvsp[-2].peer_option_list);
   (yyval.peer_option_list)->append((yyvsp[0].peer_option));
}
#line 5303 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 374:
#line 2021 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.peer_option) = new AttrPeerOption((yyvsp[-3].string), (yyvsp[-1].list));
}
#line 5311 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 376:
#line 2027 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.ip) = new IPAddr;
}
#line 5319 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 377:
#line 2030 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.ip) = new IPAddr;
}
#line 5327 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 378:
#line 2033 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.ip) = new IPAddr;
}
#line 5335 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 379:
#line 2038 "rpsl.y" /* yacc.c:1648  */
    {
   const AttrProtocol *protocol = schema.searchProtocol((yyvsp[-3].string));
   int position;
   const RPType *correctType;
   bool error = false;

   if (!protocol) {
      handle_error("Error: unknown protocol %s.\n", (yyvsp[-3].string));
      error = true;
   } else {
      ((AttrProtocol *) protocol)->startMandatoryCheck();
      for (AttrPeerOption *opt = (yyvsp[-1].peer_option_list)->head(); opt; opt = (yyvsp[-1].peer_option_list)->next(opt)) {
	 const AttrProtocolOption *decl = protocol->searchOption(opt->option);
	 if (!decl)  {
	    handle_error("Error: protocol %s does not have option %s.\n", 
			 (yyvsp[-3].string), opt->option);
	    error = true;
	 } else {
	    for (; decl; decl = protocol->searchNextOption(decl))
	       if (decl->option->validateArgs(opt->args, position, correctType))
		  break;
	    if (! decl) {
	       if (! (!strcasecmp(protocol->name, "BGP4")
		      && !strcasecmp(opt->option, "asno")
		      && opt->args->isSingleton()
		      && typeid(*opt->args->head()) == typeid(ItemWORD)
		      && !strcasecmp(((ItemWORD *) opt->args->head())->word,
				     "peeras"))) {
		  handleArgumentTypeError((yyvsp[-3].string), opt->option, position, 
					  correctType);
		  error = true;
	       }
	    }
	 }
      }
   }

   if (! error) {
      const AttrProtocolOption *missing = 
	 ((AttrProtocol *) protocol)->missingMandatoryOption();
      if (missing) {
	 handle_error("Error: mandatory option %s of protocol %s is missing.\n", 
		      missing->option->name, (yyvsp[-3].string));
	 error = true;
      }
   }
      
   if (!error)
      //$$ = changeCurrentAttr(new AttrPeer(protocol, $3, $4));
      (yyval.attr) = changeCurrentAttr(new AttrPeer(protocol, new MPPrefix((PrefixRange *) (yyvsp[-2].ip)), (yyvsp[-1].peer_option_list)));
   else {
      free((yyvsp[-3].string));
      delete (yyvsp[-2].ip);
      delete (yyvsp[-1].peer_option_list);
   }
}
#line 5396 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 380:
#line 2094 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-4].attr);
   free((yyvsp[-3].string));
   delete (yyvsp[-2].ip);
   handle_error("Error: in peer option.\n");
   yyerrok;
}
#line 5408 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 381:
#line 2101 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-3].attr);
   free((yyvsp[-2].string));
   handle_error("Error: missing peer ip_address.\n");
   yyerrok;
}
#line 5419 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 382:
#line 2107 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   handle_error("Error: missing protocol name.\n");
   yyerrok;
}
#line 5429 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 383:
#line 2116 "rpsl.y" /* yacc.c:1648  */
    { 
   const AttrProtocol *protocol = schema.searchProtocol((yyvsp[-3].string));
   int position;
   const RPType *correctType;
   bool error = false;

   if (!protocol) {
      handle_error("Error: unknown protocol %s.\n", (yyvsp[-3].string));
      error = true;
   } else {
      ((AttrProtocol *) protocol)->startMandatoryCheck();
      for (AttrPeerOption *opt = (yyvsp[-1].peer_option_list)->head(); opt; opt = (yyvsp[-1].peer_option_list)->next(opt)) {
         const AttrProtocolOption *decl = protocol->searchOption(opt->option);
         if (!decl)  {
            handle_error("Error: protocol %s does not have option %s.\n", 
                         (yyvsp[-3].string), opt->option);
            error = true;
         } else {
            for (; decl; decl = protocol->searchNextOption(decl))
               if (decl->option->validateArgs(opt->args, position, correctType))
                  break;
            if (! decl) {
               if (! (!strcasecmp(protocol->name, "BGP4")
                      && !strcasecmp(opt->option, "asno")
                      && opt->args->isSingleton()
                      && typeid(*opt->args->head()) == typeid(ItemWORD)
                      && !strcasecmp(((ItemWORD *) opt->args->head())->word,
                                     "peeras"))) {
                  handleArgumentTypeError((yyvsp[-3].string), opt->option, position, 
                                          correctType);
                  error = true;
               }
            }
         }
      }
   }

   if (! error) {
      const AttrProtocolOption *missing = 
         ((AttrProtocol *) protocol)->missingMandatoryOption();
      if (missing) {
         handle_error("Error: mandatory option %s of protocol %s is missing.\n", 
                      missing->option->name, (yyvsp[-3].string));
         error = true;
      }
   }
      
   if (!error) {
     (yyval.attr) = changeCurrentAttr(new AttrPeer(protocol, (yyvsp[-2].mpprefix), (yyvsp[-1].peer_option_list)));
   }
   else {
      free((yyvsp[-3].string));
      delete (yyvsp[-2].mpprefix);
      delete (yyvsp[-1].peer_option_list);
   }
  
}
#line 5491 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 384:
#line 2173 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-4].attr);
   free((yyvsp[-3].string));
   delete (yyvsp[-2].mpprefix);
   handle_error("Error: in peer option.\n");
   yyerrok;
}
#line 5503 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 385:
#line 2180 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-3].attr);
   free((yyvsp[-2].string));
   handle_error("Error: missing peer ip_address.\n");
   yyerrok;
}
#line 5514 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 386:
#line 2186 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   handle_error("Error: missing protocol name.\n");
   yyerrok;
}
#line 5524 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 387:
#line 2193 "rpsl.y" /* yacc.c:1648  */
    {
  (yyval.mpprefix) = new MPPrefix((yyvsp[0].ip));
}
#line 5532 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 388:
#line 2196 "rpsl.y" /* yacc.c:1648  */
    {
  (yyval.mpprefix) = new MPPrefix((yyvsp[0].ipv6));
}
#line 5540 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 389:
#line 2199 "rpsl.y" /* yacc.c:1648  */
    {
  (yyval.mpprefix) = new MPPrefix;
}
#line 5548 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 390:
#line 2202 "rpsl.y" /* yacc.c:1648  */
    {
//   $$ = new IPAddr;
  (yyval.mpprefix) = new MPPrefix;
}
#line 5557 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 391:
#line 2206 "rpsl.y" /* yacc.c:1648  */
    {
//   $$ = new IPAddr;
  (yyval.mpprefix) = new MPPrefix;
}
#line 5566 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 392:
#line 2218 "rpsl.y" /* yacc.c:1648  */
    {
  (yyval.attr) = changeCurrentAttr(new AttrFilter((yyvsp[-1].filter)));
}
#line 5574 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 393:
#line 2221 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   handle_error("Error: badly formed filter.\n");
   yyerrok;
}
#line 5584 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 394:
#line 2228 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterOR((yyvsp[-2].filter), (yyvsp[0].filter));
}
#line 5592 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 395:
#line 2231 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterOR((yyvsp[-1].filter), (yyvsp[0].filter));
}
#line 5600 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 397:
#line 2237 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterAND((yyvsp[-2].filter), (yyvsp[0].filter));
}
#line 5608 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 399:
#line 2243 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterNOT((yyvsp[0].filter));
}
#line 5616 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 400:
#line 2246 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = (yyvsp[-1].filter);
}
#line 5624 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 402:
#line 2252 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterANY;
}
#line 5632 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 403:
#line 2255 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterASPath((yyvsp[-1].re));
}
#line 5640 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 404:
#line 2258 "rpsl.y" /* yacc.c:1648  */
    {
   if ((yyvsp[0].filter))
      (yyval.filter) = (yyvsp[0].filter);
   else
      (yyval.filter) = new FilterNOT(new FilterANY);
}
#line 5651 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 405:
#line 2264 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterFLTRNAME((yyvsp[0].sid));
}
#line 5659 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 407:
#line 2270 "rpsl.y" /* yacc.c:1648  */
    {
   (yyvsp[0].moreSpecOp)->f1 = (yyvsp[-1].filter);
   (yyval.filter) = (yyvsp[0].moreSpecOp);
}
#line 5668 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 409:
#line 2277 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterASNO((yyvsp[0].i));
}
#line 5676 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 410:
#line 2280 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterPeerAS;
}
#line 5684 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 411:
#line 2283 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterASNAME((yyvsp[0].sid));
}
#line 5692 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 412:
#line 2286 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterRSNAME((yyvsp[0].sid));
}
#line 5700 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 413:
#line 2289 "rpsl.y" /* yacc.c:1648  */
    { 
   (yyval.filter) = (yyvsp[-1].filter); 
}
#line 5708 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 414:
#line 2294 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterMPPRFXList;
}
#line 5716 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 416:
#line 2300 "rpsl.y" /* yacc.c:1648  */
    {

   ((FilterMPPRFXList *) ((yyval.filter) = new FilterMPPRFXList))->push_back(*(yyvsp[0].mpprefix));
}
#line 5725 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 417:
#line 2304 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = (yyvsp[-2].filter);
   ((FilterMPPRFXList *) ((yyval.filter)))->push_back(*(yyvsp[0].mpprefix));
}
#line 5734 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 418:
#line 2311 "rpsl.y" /* yacc.c:1648  */
    {
  (yyval.mpprefix) = new MPPrefix((yyvsp[0].prfxv6));
}
#line 5742 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 419:
#line 2314 "rpsl.y" /* yacc.c:1648  */
    {
  (yyval.mpprefix) = new MPPrefix((yyvsp[0].prfxv6rng));
}
#line 5750 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 420:
#line 2321 "rpsl.y" /* yacc.c:1648  */
    {
  (yyval.attr) = (yyvsp[-3].attr);
}
#line 5758 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 421:
#line 2324 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   handle_error("Error: [ATOMIC] [[<filter>] [PROTOCOL <protocol> <filter>] ...] expected.\n");
   yyerrok;
}
#line 5768 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 422:
#line 2331 "rpsl.y" /* yacc.c:1648  */
    {
}
#line 5775 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 423:
#line 2333 "rpsl.y" /* yacc.c:1648  */
    {
   delete (yyvsp[0].filter);
}
#line 5783 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 424:
#line 2336 "rpsl.y" /* yacc.c:1648  */
    {
   free((yyvsp[-1].string));
   delete (yyvsp[0].filter);
}
#line 5792 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 425:
#line 2347 "rpsl.y" /* yacc.c:1648  */
    {
  (yyval.attr) = (yyvsp[-4].attr);
  delete (yyvsp[-3].filter);
  delete (yyvsp[-2].actionList);
  delete (yyvsp[-1].filter);
  
}
#line 5804 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 426:
#line 2354 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   handle_error("Error: [at <router-exp>] [action <action>] [upon <condition>] expected.\n");
   yyerrok;
}
#line 5814 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 427:
#line 2361 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterANY;
}
#line 5822 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 428:
#line 2364 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = (yyvsp[0].filter);
}
#line 5830 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 429:
#line 2369 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterOR((yyvsp[-2].filter), (yyvsp[0].filter));
}
#line 5838 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 430:
#line 2372 "rpsl.y" /* yacc.c:1648  */
    {
}
#line 5845 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 431:
#line 2376 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterAND((yyvsp[-2].filter), (yyvsp[0].filter));
}
#line 5853 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 433:
#line 2382 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = (yyvsp[-1].filter);
}
#line 5861 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 435:
#line 2388 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterANY;
}
#line 5869 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 436:
#line 2391 "rpsl.y" /* yacc.c:1648  */
    { 
   (yyval.filter) = new FilterV6HAVE_COMPONENTS((FilterMPPRFXList *) (yyvsp[-1].filter)); 
}
#line 5877 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 437:
#line 2394 "rpsl.y" /* yacc.c:1648  */
    { 
   (yyval.filter) = new FilterV6EXCLUDE((FilterMPPRFXList *) (yyvsp[-1].filter)); 
}
#line 5885 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 438:
#line 2401 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   delete (yyvsp[-1].filter);
}
#line 5894 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 439:
#line 2405 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   handle_error("Error: <as-expression> expected.\n");
   yyerrok;
}
#line 5904 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 440:
#line 2412 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
}
#line 5912 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 441:
#line 2415 "rpsl.y" /* yacc.c:1648  */
    {
   delete (yyvsp[-1].filter);
}
#line 5920 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 442:
#line 2418 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-3].attr);
   handle_error("Error: OUTBOUND <as-expression> expected.\n");
   yyerrok;
}
#line 5930 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 443:
#line 2423 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-3].attr);
   handle_error("Error: INBOUND can not be followed by anything.\n");
   yyerrok;
}
#line 5940 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 444:
#line 2428 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   handle_error("Error: keyword INBOUND or OUTBOUND expected.\n");
   yyerrok;
}
#line 5950 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 445:
#line 2437 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterANY;
}
#line 5958 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 446:
#line 2440 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = (yyvsp[0].filter);
}
#line 5966 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 447:
#line 2445 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterOR((yyvsp[-2].filter), (yyvsp[0].filter));
}
#line 5974 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 449:
#line 2451 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterAND((yyvsp[-2].filter), (yyvsp[0].filter));
}
#line 5982 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 451:
#line 2457 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = (yyvsp[-1].filter);
}
#line 5990 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 453:
#line 2463 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.filter) = new FilterANY;
}
#line 5998 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 454:
#line 2466 "rpsl.y" /* yacc.c:1648  */
    { 
   (yyval.filter) = new FilterHAVE_COMPONENTS((FilterPRFXList *) (yyvsp[-1].filter)); 
}
#line 6006 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 455:
#line 2469 "rpsl.y" /* yacc.c:1648  */
    { 
   (yyval.filter) = new FilterEXCLUDE((FilterPRFXList *) (yyvsp[-1].filter)); 
}
#line 6014 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 456:
#line 2474 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-4].attr);
   delete (yyvsp[-3].filter);
   delete (yyvsp[-2].actionList);
   delete (yyvsp[-1].filter);
}
#line 6025 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 457:
#line 2480 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   handle_error("Error: [at <router-exp>] [action <action>] [upon <condition>] expected.\n");
   yyerrok;
}
#line 6035 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 460:
#line 2493 "rpsl.y" /* yacc.c:1648  */
    {
}
#line 6042 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 461:
#line 2495 "rpsl.y" /* yacc.c:1648  */
    {
   delete (yyvsp[0].filter);
}
#line 6050 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 462:
#line 2498 "rpsl.y" /* yacc.c:1648  */
    {
   free((yyvsp[-1].string));
   delete (yyvsp[0].filter);
}
#line 6059 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 463:
#line 2504 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-3].attr);
}
#line 6067 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 464:
#line 2507 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   handle_error("Error: [ATOMIC] [[<filter>] [PROTOCOL <protocol> <filter>] ...] expected.\n");
   yyerrok;
}
#line 6077 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 465:
#line 2516 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.list) = new ItemList;
}
#line 6085 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 466:
#line 2519 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.list) = (yyvsp[0].list);
}
#line 6093 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 467:
#line 2524 "rpsl.y" /* yacc.c:1648  */
    { 	
   (yyval.list) = new ItemList;
   (yyval.list)->append((yyvsp[0].item));
}
#line 6102 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 468:
#line 2528 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.list) = (yyvsp[-2].list);
   (yyval.list)->append((yyvsp[0].item));
}
#line 6111 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 469:
#line 2534 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemASNO((yyvsp[0].i));
}
#line 6119 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 470:
#line 2537 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemMSItem(new ItemASNO((yyvsp[-1].i)), (yyvsp[0].moreSpecOp)->code, (yyvsp[0].moreSpecOp)->n, (yyvsp[0].moreSpecOp)->m);
   delete (yyvsp[0].moreSpecOp);
}
#line 6128 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 471:
#line 2541 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemASNAME((yyvsp[0].sid));
}
#line 6136 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 472:
#line 2544 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemMSItem(new ItemASNAME((yyvsp[-1].sid)), (yyvsp[0].moreSpecOp)->code, (yyvsp[0].moreSpecOp)->n, (yyvsp[0].moreSpecOp)->m);
   delete (yyvsp[0].moreSpecOp);
}
#line 6145 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 473:
#line 2548 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemRSNAME((yyvsp[0].sid));
}
#line 6153 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 474:
#line 2551 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemMSItem(new ItemRSNAME((yyvsp[-1].sid)), (yyvsp[0].moreSpecOp)->code, (yyvsp[0].moreSpecOp)->n, (yyvsp[0].moreSpecOp)->m);
   delete (yyvsp[0].moreSpecOp);
}
#line 6162 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 475:
#line 2555 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemPRFXV4((yyvsp[0].prfx));
}
#line 6170 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 476:
#line 2558 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemPRFXV4Range((yyvsp[0].prfxrng));
}
#line 6178 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 477:
#line 2563 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = changeCurrentAttr(new AttrGeneric((yyvsp[-2].attr)->type, (yyvsp[-1].list)));
}
#line 6186 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 478:
#line 2566 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   handle_error("Error: invalid member\n");
   yyerrok;
}
#line 6196 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 479:
#line 2575 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.list) = new ItemList;
}
#line 6204 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 480:
#line 2578 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.list) = (yyvsp[0].list);
}
#line 6212 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 481:
#line 2583 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.list) = new ItemList;
   (yyval.list)->append((yyvsp[0].item));
}
#line 6221 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 482:
#line 2587 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.list) = (yyvsp[-2].list);
   (yyval.list)->append((yyvsp[0].item));
}
#line 6230 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 483:
#line 2593 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemASNO((yyvsp[0].i));
}
#line 6238 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 484:
#line 2596 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemMSItem(new ItemASNO((yyvsp[-1].i)), (yyvsp[0].moreSpecOp)->code, (yyvsp[0].moreSpecOp)->n, (yyvsp[0].moreSpecOp)->m);
   delete (yyvsp[0].moreSpecOp);
}
#line 6247 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 485:
#line 2600 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemASNAME((yyvsp[0].sid));
}
#line 6255 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 486:
#line 2603 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemMSItem(new ItemASNAME((yyvsp[-1].sid)), (yyvsp[0].moreSpecOp)->code, (yyvsp[0].moreSpecOp)->n, (yyvsp[0].moreSpecOp)->m);
   delete (yyvsp[0].moreSpecOp);
}
#line 6264 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 487:
#line 2607 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemRSNAME((yyvsp[0].sid));
}
#line 6272 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 488:
#line 2610 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemMSItem(new ItemRSNAME((yyvsp[-1].sid)), (yyvsp[0].moreSpecOp)->code, (yyvsp[0].moreSpecOp)->n, (yyvsp[0].moreSpecOp)->m);
   delete (yyvsp[0].moreSpecOp);
}
#line 6281 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 489:
#line 2614 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemPRFXV4((yyvsp[0].prfx));
}
#line 6289 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 490:
#line 2617 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemPRFXV4Range((yyvsp[0].prfxrng));
}
#line 6297 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 491:
#line 2620 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemPRFXV6((yyvsp[0].prfxv6));
}
#line 6305 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 492:
#line 2623 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.item) = new ItemPRFXV6Range((yyvsp[0].prfxv6rng));
}
#line 6313 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 493:
#line 2628 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = changeCurrentAttr(new AttrGeneric((yyvsp[-2].attr)->type, (yyvsp[-1].list)));
}
#line 6321 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 494:
#line 2631 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   handle_error("Error: invalid member\n");
   yyerrok;
}
#line 6331 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 495:
#line 2640 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = changeCurrentAttr(new AttrRPAttr((yyvsp[-2].string), (yyvsp[-1].methodlist)));
}
#line 6339 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 496:
#line 2643 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = changeCurrentAttr(new AttrRPAttr((yyvsp[-2].rp_attr)->name, (yyvsp[-1].methodlist)));
}
#line 6347 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 497:
#line 2646 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   handle_error("Error: invalid rp-attribute specification\n");
   yyerrok;
}
#line 6357 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 498:
#line 2653 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.methodlist) = new List<AttrMethod>;
   if ((yyvsp[0].method))
      (yyval.methodlist)->append((yyvsp[0].method));
}
#line 6367 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 499:
#line 2658 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.methodlist) = (yyvsp[-1].methodlist);
   if ((yyvsp[0].method))
      (yyval.methodlist)->append((yyvsp[0].method));
}
#line 6377 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 500:
#line 2665 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.method) = new AttrMethod((yyvsp[-2].string), new List<RPTypeNode>, false);
}
#line 6385 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 501:
#line 2668 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.method) = new AttrMethod((yyvsp[-3].string), (yyvsp[-1].typelist), false);
}
#line 6393 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 502:
#line 2671 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.method) = new AttrMethod((yyvsp[-5].string), (yyvsp[-3].typelist), true);
}
#line 6401 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 503:
#line 2674 "rpsl.y" /* yacc.c:1648  */
    {
   char buffer[16];
   strcpy(buffer, "operator");
   strcat(buffer, (yyvsp[-3].string));
   (yyval.method) = new AttrMethod(strdup(buffer), (yyvsp[-1].typelist), false, true);
   free((yyvsp[-3].string));
}
#line 6413 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 504:
#line 2681 "rpsl.y" /* yacc.c:1648  */
    {
   char buffer[16];
   strcpy(buffer, "operator");
   strcat(buffer, (yyvsp[-5].string));
   (yyval.method) = new AttrMethod(strdup(buffer), (yyvsp[-3].typelist), true, true);
   free((yyvsp[-5].string));
}
#line 6425 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 505:
#line 2688 "rpsl.y" /* yacc.c:1648  */
    {
   free((yyvsp[-2].string));
   (yyval.method) = NULL;
   handle_error("Error: invalid method specification for %s\n", (yyvsp[-2].string));
}
#line 6435 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 506:
#line 2693 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.method) = NULL;
   handle_error("Error: invalid operator specification for %s\n", (yyvsp[-2].string));
   free((yyvsp[-2].string));
}
#line 6445 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 507:
#line 2698 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.method) = NULL;
   handle_error("Error: invalid operator\n");
}
#line 6454 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 508:
#line 2702 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.method) = NULL;
   handle_error("Error: method specification expected\n");
}
#line 6463 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 509:
#line 2710 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = changeCurrentAttr(new AttrTypedef((yyvsp[-2].string), (yyvsp[-1].typenode)));
}
#line 6471 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 510:
#line 2713 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   handle_error("Error: invalid typedef specification\n");
   yyerrok;
}
#line 6481 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 511:
#line 2720 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.typelist) = new List<RPTypeNode>;
   if ((yyvsp[0].typenode))
      (yyval.typelist)->append(new RPTypeNode((yyvsp[0].typenode)));
}
#line 6491 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 512:
#line 2725 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.typelist) = (yyvsp[-2].typelist);
   if ((yyvsp[0].typenode))
      (yyval.typelist)->append(new RPTypeNode((yyvsp[0].typenode)));
}
#line 6501 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 513:
#line 2732 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.typenode) = RPType::newRPType("union", (yyvsp[0].typelist));
   if (!(yyval.typenode)) {
      handle_error("Error: empty union specification\n");
      delete (yyvsp[0].typelist);
   }
}
#line 6513 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 514:
#line 2739 "rpsl.y" /* yacc.c:1648  */
    {
   if ((yyvsp[0].typenode))
      (yyval.typenode) = new RPTypeRange((yyvsp[0].typenode));
   else {
      (yyval.typenode) = NULL;
   }
}
#line 6525 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 515:
#line 2746 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.typenode) = RPType::newRPType((yyvsp[0].string));
   if (!(yyval.typenode)) {
      handle_error("Error: invalid type %s\n", (yyvsp[0].string));
   }
   free((yyvsp[0].string));
}
#line 6537 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 516:
#line 2753 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.typenode) = RPType::newRPType((yyvsp[-5].string), (yyvsp[-3].i), (yyvsp[-1].i));
   if (!(yyval.typenode)) {
      handle_error("Error: invalid type %s[%d,%d]\n", (yyvsp[-5].string), (yyvsp[-3].i), (yyvsp[-1].i));
   }
   free((yyvsp[-5].string));
}
#line 6549 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 517:
#line 2760 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.typenode) = RPType::newRPType((yyvsp[-5].string), (yyvsp[-3].real), (yyvsp[-1].real));
   if (!(yyval.typenode)) {
      handle_error("Error: invalid type %s[%f,%f]\n", (yyvsp[-5].string), (yyvsp[-3].real), (yyvsp[-1].real));
   }
   free((yyvsp[-5].string));
}
#line 6561 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 518:
#line 2767 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.typenode) = RPType::newRPType((yyvsp[-3].string), (yyvsp[-1].wordlist));
   if (!(yyval.typenode)) {
      handle_error("Error: invalid type %s, enum expected\n", (yyvsp[-3].string));
      delete (yyvsp[-1].wordlist);
   }
   free((yyvsp[-3].string));
}
#line 6574 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 519:
#line 2775 "rpsl.y" /* yacc.c:1648  */
    {
   if ((yyvsp[0].typenode))
      if ((yyvsp[-5].i) < (yyvsp[-3].i))
	 (yyval.typenode) = new RPTypeList((yyvsp[0].typenode), (yyvsp[-5].i), (yyvsp[-3].i));
      else
	 (yyval.typenode) = new RPTypeList((yyvsp[0].typenode), (yyvsp[-3].i), (yyvsp[-5].i));
   else {
      (yyval.typenode) = NULL;
      delete (yyvsp[0].typenode);
   }
}
#line 6590 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 520:
#line 2786 "rpsl.y" /* yacc.c:1648  */
    {
   if ((yyvsp[0].typenode))
      (yyval.typenode) = new RPTypeList((yyvsp[0].typenode));
   else {
      (yyval.typenode) = NULL;
   }
}
#line 6602 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 521:
#line 2793 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.typenode) = NULL;
   delete (yyvsp[0].typenode);
   handle_error("Error: invalid list size\n");
}
#line 6612 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 522:
#line 2800 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.wordlist) = new List<WordNode>;
   (yyval.wordlist)->append(new WordNode((yyvsp[0].string)));
}
#line 6621 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 523:
#line 2804 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.wordlist) = (yyvsp[-2].wordlist);
   (yyval.wordlist)->append(new WordNode((yyvsp[0].string)));
}
#line 6630 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 524:
#line 2812 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = changeCurrentAttr(new AttrProtocol((yyvsp[-2].string), (yyvsp[-1].protocol_option_list)));
}
#line 6638 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 525:
#line 2815 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-3].attr);
   handle_error("Error: invalid protocol option\n");
   yyerrok;
}
#line 6648 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 526:
#line 2820 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   handle_error("Error: invalid protocol name\n");
   yyerrok;
}
#line 6658 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 527:
#line 2827 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.protocol_option_list) = new List<AttrProtocolOption>;
}
#line 6666 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 528:
#line 2830 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.protocol_option_list) = (yyvsp[-1].protocol_option_list);
   (yyval.protocol_option_list)->append((yyvsp[0].protocol_option));
}
#line 6675 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 529:
#line 2836 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.protocol_option) = new AttrProtocolOption(false, (yyvsp[0].method));
}
#line 6683 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 530:
#line 2839 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.protocol_option) = new AttrProtocolOption(true, (yyvsp[0].method));
}
#line 6691 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 531:
#line 2846 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.rpslattr) = new AttrAttr(ATTR_GENERIC, RPType::newRPType("free_text"));
}
#line 6699 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 532:
#line 2849 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.rpslattr) = new AttrAttr(ATTR_GENERIC, RPType::newRPType("free_text"));
   *(yyval.rpslattr) |= *(yyvsp[0].rpslattr);
   delete (yyvsp[0].rpslattr);
}
#line 6709 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 533:
#line 2856 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.rpslattr) = (yyvsp[0].rpslattr);
}
#line 6717 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 534:
#line 2859 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.rpslattr) = (yyvsp[-2].rpslattr);
   *(yyval.rpslattr) |= *(yyvsp[0].rpslattr);
   delete (yyvsp[0].rpslattr);
}
#line 6727 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 535:
#line 2864 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.rpslattr) = (yyvsp[0].rpslattr);
   handle_error("Error: in attr option specification.\n");
}
#line 6736 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 536:
#line 2870 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.rpslattr) = new AttrAttr(ATTR_GENERIC, (yyvsp[-1].typenode));
}
#line 6744 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 537:
#line 2873 "rpsl.y" /* yacc.c:1648  */
    {
   int syntax = schema.searchAttrSyntax((yyvsp[-1].string));
   if (syntax < 0) {
      handle_error("Error: no known syntax rule for %s.\n", (yyvsp[-1].string));
      (yyval.rpslattr) = new AttrAttr;
   } else
      (yyval.rpslattr) = new AttrAttr(syntax, NULL);
   free((yyvsp[-1].string));
}
#line 6758 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 538:
#line 2882 "rpsl.y" /* yacc.c:1648  */
    {
   regex_t *re = (regex_t *) malloc(sizeof(regex_t));
   int code = regcomp(re, (yyvsp[-1].string), REG_EXTENDED | REG_ICASE);

   if (code) {
      handle_error("Error: could not compile regexp %s.\n", (yyvsp[-1].string));
      free(re);
      free((yyvsp[-1].string));
      (yyval.rpslattr) = new AttrAttr;
   } else
      (yyval.rpslattr) = new AttrAttr(ATTR_REGEXP, (yyvsp[-1].string), re);
}
#line 6775 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 539:
#line 2894 "rpsl.y" /* yacc.c:1648  */
    {
   regex_t *re = (regex_t *) malloc(sizeof(regex_t));
   int code = regcomp(re, (yyvsp[-3].string), REG_EXTENDED | REG_ICASE);

   if (code) {
      handle_error("Error: could not compile regexp %s.\n", (yyvsp[-3].string));
      free(re);
      free((yyvsp[-3].string));
      (yyval.rpslattr) = new AttrAttr;
   } else
      (yyval.rpslattr) = new AttrAttr(ATTR_REGEXP, (yyvsp[-3].string), re, (yyvsp[-1].i));
}
#line 6792 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 540:
#line 2906 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.rpslattr) = new AttrAttr(AttrAttr::OPTIONAL);
}
#line 6800 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 541:
#line 2909 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.rpslattr) = new AttrAttr;
}
#line 6808 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 542:
#line 2912 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.rpslattr) = new AttrAttr(AttrAttr::DELETED);
}
#line 6816 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 543:
#line 2915 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.rpslattr) = new AttrAttr;
}
#line 6824 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 544:
#line 2918 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.rpslattr) = new AttrAttr(AttrAttr::MULTIVALUED);
}
#line 6832 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 545:
#line 2921 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.rpslattr) = new AttrAttr(AttrAttr::LOOKUP);
}
#line 6840 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 546:
#line 2924 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.rpslattr) = new AttrAttr(AttrAttr::KEY);
}
#line 6848 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 547:
#line 2927 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.rpslattr) = new AttrAttr(AttrAttr::OBSOLETE);
}
#line 6856 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 548:
#line 2930 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.rpslattr) = new AttrAttr(AttrAttr::INTERNAL);
}
#line 6864 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 549:
#line 2935 "rpsl.y" /* yacc.c:1648  */
    {
   (yyvsp[-1].rpslattr)->setName((yyvsp[-2].string));
   (yyval.attr) = changeCurrentAttr((yyvsp[-1].rpslattr));
}
#line 6873 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 550:
#line 2939 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-3].attr);
   free((yyvsp[-2].string));
   handle_error("Error: in attr option specification.\n");
   yyerrok;
}
#line 6884 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 551:
#line 2945 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = (yyvsp[-2].attr);
   handle_error("Error: attr name expected.\n");
   yyerrok;
}
#line 6894 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 552:
#line 2955 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = changeCurrentAttr(new AttrMntRoutes((yyvsp[-1].listMntPrfxPair)));
}
#line 6902 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 553:
#line 2960 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.listMntPrfxPair) = new List<AttrMntRoutes::MntPrfxPair>;
   (yyval.listMntPrfxPair)->append((yyvsp[0].mntPrfxPair));
}
#line 6911 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 554:
#line 2964 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.listMntPrfxPair) = (yyvsp[-2].listMntPrfxPair);
   (yyval.listMntPrfxPair)->append((yyvsp[0].mntPrfxPair));
}
#line 6920 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 555:
#line 2970 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.mntPrfxPair) = new AttrMntRoutes::MntPrfxPair((yyvsp[0].string), NULL);
}
#line 6928 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 556:
#line 2973 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.mntPrfxPair) = new AttrMntRoutes::MntPrfxPair((yyvsp[-1].string), NULL);
}
#line 6936 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 557:
#line 2976 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.mntPrfxPair) = new AttrMntRoutes::MntPrfxPair((yyvsp[-3].string), (FilterMPPRFXList *) (yyvsp[-1].filter));
}
#line 6944 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 558:
#line 2983 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = changeCurrentAttr(new AttrMntRoutes((yyvsp[-1].listMntPrfxPair)));
}
#line 6952 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 559:
#line 2987 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.listMntPrfxPair) = new List<AttrMntRoutes::MntPrfxPair>;
   (yyval.listMntPrfxPair)->append((yyvsp[0].mntPrfxPair));
}
#line 6961 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 560:
#line 2991 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.listMntPrfxPair) = (yyvsp[-2].listMntPrfxPair);
   (yyval.listMntPrfxPair)->append((yyvsp[0].mntPrfxPair));
}
#line 6970 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 561:
#line 2997 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.mntPrfxPair) = new AttrMntRoutes::MntPrfxPair((yyvsp[0].string), NULL);
}
#line 6978 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 562:
#line 3000 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.mntPrfxPair) = new AttrMntRoutes::MntPrfxPair((yyvsp[-1].string), NULL);
}
#line 6986 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 563:
#line 3003 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.mntPrfxPair) = new AttrMntRoutes::MntPrfxPair((yyvsp[-3].string), (FilterMPPRFXList *) (yyvsp[-1].filter));
}
#line 6994 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 564:
#line 3010 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.attr) = changeCurrentAttr(new AttrMntRoutes((yyvsp[-1].listMntPrfxPair)));
}
#line 7002 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 565:
#line 3014 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.listMntPrfxPair) = new List<AttrMntRoutes::MntPrfxPair>;
   (yyval.listMntPrfxPair)->append((yyvsp[0].mntPrfxPair));
}
#line 7011 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 566:
#line 3018 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.listMntPrfxPair) = (yyvsp[-2].listMntPrfxPair);
   (yyval.listMntPrfxPair)->append((yyvsp[0].mntPrfxPair));
}
#line 7020 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 567:
#line 3024 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.mntPrfxPair) = new AttrMntRoutes::MntPrfxPair((yyvsp[0].string), NULL);
}
#line 7028 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 568:
#line 3027 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.mntPrfxPair) = new AttrMntRoutes::MntPrfxPair((yyvsp[-1].string), NULL);
}
#line 7036 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 569:
#line 3030 "rpsl.y" /* yacc.c:1648  */
    {
   (yyval.mntPrfxPair) = new AttrMntRoutes::MntPrfxPair((yyvsp[-3].string), (FilterMPPRFXList *) (yyvsp[-1].filter));
}
#line 7044 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 570:
#line 3043 "rpsl.y" /* yacc.c:1648  */
    {
  (yyval.list) = (yyvsp[0].list);
}
#line 7052 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 571:
#line 3046 "rpsl.y" /* yacc.c:1648  */
    {
  (yyval.list) = new ItemList;
  (yyval.list)->append(new ItemAFI("any"));
  (yyval.list) = (yyval.list)->expand();
}
#line 7062 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 572:
#line 3053 "rpsl.y" /* yacc.c:1648  */
    {
  (yyval.list) = new ItemList;
  (yyval.list)->append((yyvsp[0].item));
  (yyval.list) = (yyval.list)->expand();
}
#line 7072 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 573:
#line 3058 "rpsl.y" /* yacc.c:1648  */
    {
  (yyval.list) = (yyvsp[-2].list);
	(yyval.list)->append((yyvsp[0].item));
  (yyval.list) = (yyval.list)->expand();
}
#line 7082 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 574:
#line 3065 "rpsl.y" /* yacc.c:1648  */
    {
    (yyval.item) = new ItemAFI((yyvsp[0].afi));
}
#line 7090 "rpsl.y.cc" /* yacc.c:1648  */
    break;

  case 575:
#line 3068 "rpsl.y" /* yacc.c:1648  */
    {
    // workaround for clashing 'any'
    (yyval.item) = new ItemAFI("any");
}
#line 7099 "rpsl.y.cc" /* yacc.c:1648  */
    break;


#line 7103 "rpsl.y.cc" /* yacc.c:1648  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 3074 "rpsl.y" /* yacc.c:1907  */


void enable_yy_parser_debugging() {
#if YYDEBUG != 0
   yydebug = 1;
#endif
}

void handleArgumentTypeError(char *attr, const char *method, int position,
			     const RPType *correctType, 
			     bool isOperator) {
   if (isOperator)
      if (position)
	 handle_error("Error: argument %d to %s.operator%s should be %s.\n",
		   position, attr, method, ((RPType *) correctType)->name());
      else
	 handle_error("Error: wrong number of arguments to %s.operator%s.\n",
		      attr, method);
   else
      if (position)
	 handle_error("Error: argument %d to %s.%s should be %s.\n",
		   position, attr, method, ((RPType *) correctType)->name());
      else
	 handle_error("Error: wrong number of arguments to %s.%s.\n",
		      attr, method);
}

const AttrMethod *searchMethod(const AttrRPAttr *rp_attr, const char *method, ItemList *args) {
   const AttrMethod *mtd = rp_attr->searchMethod(method);
   int position;
   const RPType *correctType;
   
   if (!mtd) {
      handle_error("Error: rp-attribute %s does not have %s defined.\n",
		   rp_attr->name, method);
      return NULL;
   }
   
   for (; mtd; mtd = rp_attr->searchNextMethod(mtd))
      if (mtd->validateArgs(args, position, correctType))
	 return mtd;

   handleArgumentTypeError(rp_attr->name, method, position, correctType);
   
   return NULL;
}
